/*

	Zhuravli A script authoring library
	Copyright (C) 2000-2006  W.Dee <dee@kikyou.info> and contributors
	Copyright (C) 2006  mey

*/
/* This file is always generated by maketjsstub.pl . */
/* Modification by hand will be lost. */
#ifndef __ZHURAVLI_STUB_H__
#define __ZHURAVLI_STUB_H__

#ifndef __cplusplus
	#error Sorry, currently tp_stub.h can only be used in C++ mode.
#endif

#ifndef _WIN32
	#error Sorry, currently tp_stub.h can only be used in Win32 VC++ or Borland compilers.
#endif

#include <stdlib.h>



typedef __int8 tjs_int8;
typedef unsigned __int8 tjs_uint8;
typedef __int16 tjs_int16;
typedef unsigned __int16 tjs_uint16;
typedef __int32 tjs_int32;
typedef unsigned __int32 tjs_uint32;
typedef __int64 tjs_int64;
typedef unsigned __int64 tjs_uint64;
typedef int tjs_int;    /* at least 32bits */
typedef unsigned int tjs_uint;    /* at least 32bits */

#ifdef __cplusplus
typedef wchar_t tjs_char;
#else
typedef unsigned short tjs_char;
#endif

typedef char tjs_nchar;
typedef double tjs_real;

#define TJS_HOST_IS_BIG_ENDIAN 0
#define TJS_HOST_IS_LITTLE_ENDIAN 1

#ifndef TJS_INTF_METHOD
#define TJS_INTF_METHOD __cdecl
	/* TJS_INTF_METHOD is "cdecl" (by default)
		since TJS2 2.4.14 (kirikir2 2.25 beta 1) */
#endif

#define TJS_USERENTRY __cdecl

#define TJS_I64_VAL(x) ((tjs_int64)(x##i64))
#define TJS_UI64_VAL(x) ((tjs_uint64)(x##i64))



#define TJS_W(X) L##X
#define TJS_N(X) X


typedef tjs_int32 tjs_error;

typedef tjs_int64 tTVInteger;
typedef tjs_real tTVReal;


/* IEEE double manipulation support
 (TJS requires IEEE double(64-bit float) native support on machine or C++ compiler) */

/*

63 62       52 51                         0
+-+-----------+---------------------------+
|s|    exp    |         significand       |
+-+-----------+---------------------------+

s = sign,  negative if this is 1, otherwise positive.



*/

/* double related constants */
#define TJS_IEEE_D_EXP_MAX 1023
#define TJS_IEEE_D_EXP_MIN -1022
#define TJS_IEEE_D_SIGNIFICAND_BITS 52

#define TJS_IEEE_D_EXP_BIAS 1023

/* component extraction */
#define TJS_IEEE_D_SIGN_MASK              (TJS_UI64_VAL(0x8000000000000000))
#define TJS_IEEE_D_EXP_MASK               (TJS_UI64_VAL(0x7ff0000000000000))
#define TJS_IEEE_D_SIGNIFICAND_MASK       (TJS_UI64_VAL(0x000fffffffffffff))
#define TJS_IEEE_D_SIGNIFICAND_MSB_MASK   (TJS_UI64_VAL(0x0008000000000000))

#define TJS_IEEE_D_GET_SIGN(x)   ((bool)(x & TJS_IEEE_D_SIGN_MASK))
#define TJS_IEEE_D_GET_EXP(x)  ((tjs_int)(((x & TJS_IEEE_D_EXP_MASK) >> \
								TJS_IEEE_D_SIGNIFICAND_BITS) - TJS_IEEE_D_EXP_BIAS))
#define TJS_IEEE_D_GET_SIGNIFICAND(x) (x & TJS_IEEE_D_SIGNIFICAND_MASK)

/* component composition */
#define TJS_IEEE_D_MAKE_SIGN(x)  ((x)?TJS_UI64_VAL(0x8000000000000000):TJS_UI64_VAL(0))
#define TJS_IEEE_D_MAKE_EXP(x)   ((tjs_uint64)(x + TJS_IEEE_D_EXP_BIAS) << 52)
#define TJS_IEEE_D_MAKE_SIGNIFICAND(x) ((tjs_uint64)(x))

/* special expression */
 /* (quiet) NaN */
  #define TJS_IEEE_D_P_NaN (tjs_uint64)(TJS_IEEE_D_EXP_MASK|TJS_IEEE_D_SIGNIFICAND_MSB_MASK)
  #define TJS_IEEE_D_N_NaN (tjs_uint64)(TJS_IEEE_D_SIGN_MASK|TJS_IEEE_D_P_NaN)
 /* infinite */
  #define TJS_IEEE_D_P_INF (tjs_uint64)(TJS_IEEE_D_EXP_MASK)
  #define TJS_IEEE_D_N_INF (tjs_uint64)(TJS_IEEE_D_SIGN_MASK|TJS_IEEE_D_P_INF)

/* special expression check */
  #define TJS_IEEE_D_IS_NaN(x) ((TJS_IEEE_D_EXP_MASK & (x)) == TJS_IEEE_D_EXP_MASK) && \
				(((x) & TJS_IEEE_D_SIGNIFICAND_MSB_MASK) || \
				(!((x) & TJS_IEEE_D_SIGNIFICAND_MSB_MASK) && \
				((x) & (TJS_IEEE_D_SIGNIFICAND_MASK ^ TJS_IEEE_D_SIGNIFICAND_MSB_MASK))))
  #define TJS_IEEE_D_IS_INF(x) (((TJS_IEEE_D_EXP_MASK & (x)) == TJS_IEEE_D_EXP_MASK) && \
				(!((x) & TJS_IEEE_D_SIGNIFICAND_MASK)))



//---------------------------------------------------------------------------
// tTJSVariantString stuff
//---------------------------------------------------------------------------
#define TJS_VS_SHORT_LEN 21


//---------------------------------------------------------------------------
// tTJSVariantString
//---------------------------------------------------------------------------
#pragma pack(push, 4)
struct tTJSVariantString_S
{
	tjs_int RefCount; // reference count - 1
	tjs_char *LongString;
	tjs_char ShortString[TJS_VS_SHORT_LEN +1];
	tjs_int Length; // string length
	tjs_uint32 HeapFlag;
	tjs_uint32 Hint;
};
#pragma pack(pop)


//---------------------------------------------------------------------------
// tTJSRefHolder : a object holder for classes that has AddRef and Release methods
//---------------------------------------------------------------------------
template <typename T>
class tTJSRefHolder
{
private:
	T *Object;
public:
	tTJSRefHolder(T * ref) { Object = ref; Object->AddRef(); }
	tTJSRefHolder(const tTJSRefHolder<T> &ref)
	{
		Object = ref.Object;
		Object->AddRef();
	}
	~tTJSRefHolder() { Object->Release(); }

	T* GetObject() { Object->AddRef(); return Object; }
	T* GetObjectNoAddRef() { return Object; }

	const tTJSRefHolder & operator = (const tTJSRefHolder & rhs)
	{
		if(rhs.Object != Object)
		{
			Object->Release();
			Object = rhs.Object;
			Object->AddRef();
		}
		return *this;
	}
};





//---------------------------------------------------------------------------
// floating-point class checker
//---------------------------------------------------------------------------
// constants used in TJSGetFPClass
#define TJS_FC_CLASS_MASK 7
#define TJS_FC_SIGN_MASK 8

#define TJS_FC_CLASS_NORMAL 0
#define TJS_FC_CLASS_NAN 1
#define TJS_FC_CLASS_INF 2

#define TJS_FC_IS_NORMAL(x)  (((x)&TJS_FC_CLASS_MASK) == TJS_FC_CLASS_NORMAL)
#define TJS_FC_IS_NAN(x)  (((x)&TJS_FC_CLASS_MASK) == TJS_FC_CLASS_NAN)
#define TJS_FC_IS_INF(x)  (((x)&TJS_FC_CLASS_MASK) == TJS_FC_CLASS_INF)

#define TJS_FC_IS_NEGATIVE(x) ((bool)((x) & TJS_FC_SIGN_MASK))
#define TJS_FC_IS_POSITIVE(x) (!TJS_FC_IS_NEGATIVE(x))




//---------------------------------------------------------------------------
// tTJSStringBufferLength
//---------------------------------------------------------------------------
#pragma pack(push, 4)
class tTJSStringBufferLength
{
public:
	tjs_int n;
	tTJSStringBufferLength(tjs_int n) {this->n = n;}
};
#pragma pack(pop)


//---------------------------------------------------------------------------
// tTJSString
//---------------------------------------------------------------------------
#pragma pack(push, 4)
class tTJSVariantString;
struct tTJSString_S
{
	tTJSVariantString *Ptr;
};
#pragma pack(pop)
class tTJSString;


typedef tTJSString ttstr;


//---------------------------------------------------------------------------
// call flag type
//---------------------------------------------------------------------------
#define TJS_MEMBERENSURE		0x00000200 // create a member if not exists
#define TJS_MEMBERMUSTEXIST     0x00000400 // member *must* exist ( for Dictionary/Array )
#define TJS_IGNOREPROP			0x00000800 // ignore property invoking
#define TJS_HIDDENMEMBER		0x00001000 // member is hidden
#define TJS_STATICMEMBER		0x00010000 // member is not registered to the
										   // object (internal use)

#define TJS_ENUM_NO_VALUE		0x00100000 // values are not retrieved
										   // (for EnumMembers)

#define TJS_NIS_REGISTER		0x00000001 // set native pointer
#define TJS_NIS_GETINSTANCE		0x00000002 // get native pointer

#define TJS_CII_ADD				0x00000001 // register name
										   // 'num' argument passed to CII is to be igonored.
#define TJS_CII_GET				0x00000000 // retrieve name

#define TJS_CII_SET_FINALIZE	0x00000002 // register "finalize" method name
										   // (set empty string not to call the method)
										   // 'num' argument passed to CII is to be igonored.
#define TJS_CII_SET_MISSING		0x00000003 // register "missing" method name.
										   // the method is called when the member is not present.
										   // (set empty string not to call the method)
										   // 'num' argument passed to CII is to be igonored.
										   // the method is to be called with three arguments;
										   // get_or_set    : false for get, true for set
										   // name          : member name
										   // value         : value property; you must
										   //               : dereference using unary '*' operator.
										   // the method must return true for found, false for not-found.

#define TJS_OL_LOCK				0x00000001 // Lock the object
#define TJS_OL_UNLOCK			0x00000002 // Unlock the object



//---------------------------------------------------------------------------
// 	Operation  flag
//---------------------------------------------------------------------------

#define TJS_OP_BAND				0x0001
#define TJS_OP_BOR				0x0002
#define TJS_OP_BXOR				0x0003
#define TJS_OP_SUB				0x0004
#define TJS_OP_ADD				0x0005
#define TJS_OP_MOD				0x0006
#define TJS_OP_DIV				0x0007
#define TJS_OP_IDIV				0x0008
#define TJS_OP_MUL				0x0009
#define TJS_OP_LOR				0x000a
#define TJS_OP_LAND				0x000b
#define TJS_OP_SAR				0x000c
#define TJS_OP_SAL				0x000d
#define TJS_OP_SR				0x000e
#define TJS_OP_INC				0x000f
#define TJS_OP_DEC				0x0010

#define TJS_OP_MASK				0x001f

#define TJS_OP_MIN				TJS_OP_BAND
#define TJS_OP_MAX				TJS_OP_DEC

/* SAR = Shift Arithmetic Right, SR = Shift (bitwise) Right */



//---------------------------------------------------------------------------
// iTJSDispatch
//---------------------------------------------------------------------------
/*
	iTJSDispatch interface
*/
class tTJSVariant;
class tTJSVariantClosure;
class tTJSVariantString;
class iTJSNativeInstance;
class iTJSDispatch2
{
/*
	methods, that have "ByNum" at the end of the name, have
	"num" parameter that enables the function to call a member with number directly.
	following two have the same effect:
	FuncCall(NULL, L"123", NULL, 0, NULL, NULL);
	FuncCallByNum(NULL, 123, NULL, 0, NULL, NULL);
*/

public:
	virtual tjs_uint TJS_INTF_METHOD AddRef(void) = 0;
	virtual tjs_uint TJS_INTF_METHOD Release(void) = 0;

public:

	virtual tjs_error TJS_INTF_METHOD
	FuncCall( // function invocation
		tjs_uint32 flag,			// calling flag
		const tjs_char * membername,// member name ( NULL for a default member )
		tjs_uint32 *hint,			// hint for the member name (in/out)
		tTJSVariant *result,		// result
		tjs_int numparams,			// number of parameters
		tTJSVariant **param,		// parameters
		iTJSDispatch2 *objthis		// object as "this"
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	FuncCallByNum( // function invocation by index number
		tjs_uint32 flag,			// calling flag
		tjs_int num,				// index number
		tTJSVariant *result,		// result
		tjs_int numparams,			// number of parameters
		tTJSVariant **param,		// parameters
		iTJSDispatch2 *objthis		// object as "this"
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	PropGet( // property get
		tjs_uint32 flag,			// calling flag
		const tjs_char * membername,// member name ( NULL for a default member )
		tjs_uint32 *hint,			// hint for the member name (in/out)
		tTJSVariant *result,		// result
		iTJSDispatch2 *objthis		// object as "this"
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	PropGetByNum( // property get by index number
		tjs_uint32 flag,			// calling flag
		tjs_int num,				// index number
		tTJSVariant *result,		// result
		iTJSDispatch2 *objthis		// object as "this"
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	PropSet( // property set
		tjs_uint32 flag,			// calling flag
		const tjs_char *membername,	// member name ( NULL for a default member )
		tjs_uint32 *hint,			// hint for the member name (in/out)
		const tTJSVariant *param,	// parameters
		iTJSDispatch2 *objthis		// object as "this"
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	PropSetByNum( // property set by index number
		tjs_uint32 flag,			// calling flag
		tjs_int num,				// index number
		const tTJSVariant *param,	// parameters
		iTJSDispatch2 *objthis		// object as "this"
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	GetCount( // get member count
		tjs_int *result,         	// variable that receives the result
		const tjs_char *membername,	// member name ( NULL for a default member )
		tjs_uint32 *hint,			// hint for the member name (in/out)
		iTJSDispatch2 *objthis      // object as "this"
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	GetCountByNum( // get member count by index number
		tjs_int *result,			// variable that receives the result
		tjs_int num,				// by index number
		iTJSDispatch2 *objthis		// object as "this"
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	PropSetByVS( // property set by tTJSVariantString, for internal use
		tjs_uint32 flag,			// calling flag
		tTJSVariantString *membername, // member name ( NULL for a default member )
		const tTJSVariant *param,	// parameters
		iTJSDispatch2 *objthis		// object as "this"
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	EnumMembers( // enumerate members
		tjs_uint32 flag,			// enumeration flag
		tTJSVariantClosure *callback,	// callback function interface ( called on each member )
		iTJSDispatch2 *objthis		// object as "this"
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	DeleteMember( // delete member
		tjs_uint32 flag,			// calling flag
		const tjs_char *membername,	// member name ( NULL for a default member )
		tjs_uint32 *hint,			// hint for the member name (in/out)
		iTJSDispatch2 *objthis		// object as "this"
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	DeleteMemberByNum( // delete member by index number
		tjs_uint32 flag,			// calling flag
		tjs_int num,				// index number
		iTJSDispatch2 *objthis		// object as "this"
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	Invalidate( // invalidation
		tjs_uint32 flag,			// calling flag
		const tjs_char *membername,	// member name ( NULL for a default member )
		tjs_uint32 *hint,			// hint for the member name (in/out)
		iTJSDispatch2 *objthis		// object as "this"
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	InvalidateByNum( // invalidation by index number
		tjs_uint32 flag,			// calling flag
		tjs_int num,				// index number
		iTJSDispatch2 *objthis		// object as "this"
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	IsValid( // get validation, returns TJS_S_TRUE (valid) or TJS_S_FALSE (invalid)
		tjs_uint32 flag,			// calling flag
		const tjs_char *membername,	// member name ( NULL for a default member )
		tjs_uint32 *hint,			// hint for the member name (in/out)
		iTJSDispatch2 *objthis		// object as "this"
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	IsValidByNum( // get validation by index number, returns TJS_S_TRUE (valid) or TJS_S_FALSE (invalid)
		tjs_uint32 flag,			// calling flag
		tjs_int num,				// index number
		iTJSDispatch2 *objthis		// object as "this"
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	CreateNew( // create new object
		tjs_uint32 flag,			// calling flag
		const tjs_char * membername,// member name ( NULL for a default member )
		tjs_uint32 *hint,			// hint for the member name (in/out)
		iTJSDispatch2 **result,		// result
		tjs_int numparams,			// number of parameters
		tTJSVariant **param,		// parameters
		iTJSDispatch2 *objthis		// object as "this"
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	CreateNewByNum( // create new object by index number
		tjs_uint32 flag,			// calling flag
		tjs_int num,				// index number
		iTJSDispatch2 **result,		// result
		tjs_int numparams,			// number of parameters
		tTJSVariant **param,		// parameters
		iTJSDispatch2 *objthis		// object as "this"
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	Reserved1(
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	IsInstanceOf( // class instance matching returns TJS_S_FALSE or TJS_S_TRUE
		tjs_uint32 flag,			// calling flag
		const tjs_char *membername,	// member name ( NULL for a default member )
		tjs_uint32 *hint,			// hint for the member name (in/out)
		const tjs_char *classname,	// class name to inquire
		iTJSDispatch2 *objthis		// object as "this"
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	IsInstanceOfByNum( // class instance matching by index number
		tjs_uint32 flag,			// calling flag
		tjs_int num,					// index number
		const tjs_char *classname,	// class name to inquire
		iTJSDispatch2 *objthis		// object as "this"
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	Operation( // operation with member
		tjs_uint32 flag,			// calling flag
		const tjs_char *membername,	// member name ( NULL for a default member )
		tjs_uint32 *hint,			// hint for the member name (in/out)
		tTJSVariant *result,		// result ( can be NULL )
		const tTJSVariant *param,	// parameters
		iTJSDispatch2 *objthis		// object as "this"
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	OperationByNum( // operation with member by index number
		tjs_uint32 flag,			// calling flag
		tjs_int num,				// index number
		tTJSVariant *result,		// result ( can be NULL )
		const tTJSVariant *param,	// parameters
		iTJSDispatch2 *objthis		// object as "this"
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	NativeInstanceSupport( // support for native instance
		tjs_uint32 flag,			// calling flag
		tjs_int32 classid,			// native class ID
		iTJSNativeInstance **pointer// object pointer
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	ClassInstanceInfo( // support for class instance information
		tjs_uint32 flag,			// calling flag
		tjs_uint num,				// index number
		tTJSVariant *value			// the name
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	Reserved2(
		) = 0;

	virtual tjs_error TJS_INTF_METHOD
	Reserved3(
		) = 0;


};
//---------------------------------------------------------------------------
class iTJSNativeInstance
{
public:
	virtual tjs_error TJS_INTF_METHOD Construct(tjs_int numparams,
		tTJSVariant **param, iTJSDispatch2 *tjs_obj) = 0;
		// TJS constructor
	virtual void TJS_INTF_METHOD Invalidate() = 0;
		// called before destruction
	virtual void TJS_INTF_METHOD Destruct() = 0;
		// must destruct itself
};


//---------------------------------------------------------------------------
// return values as tjs_error
//---------------------------------------------------------------------------
#define TJS_E_MEMBERNOTFOUND		(-1001)
#define TJS_E_NOTIMPL				(-1002)
#define TJS_E_INVALIDPARAM			(-1003)
#define TJS_E_BADPARAMCOUNT			(-1004)
#define TJS_E_INVALIDTYPE			(-1005)
#define TJS_E_INVALIDOBJECT			(-1006)
#define TJS_E_ACCESSDENYED			(-1007)
#define TJS_E_NATIVECLASSCRASH		(-1008)

#define TJS_S_TRUE					(1)
#define TJS_S_FALSE					(2)

#define TJS_S_OK                    (0)
#define TJS_E_FAIL					(-1)

#define TJS_S_MAX (2)
	// maximum possible number of success status.
	// numbers over this may be regarded as a failure in
	// strict-checking mode.

#ifdef TJS_STRICT_ERROR_CODE_CHECK
	static inline bool TJS_FAILED(tjs_error hr)
	{
		if(hr < 0) return true;
		if(hr > TJS_S_MAX) return true;
		return false;
	}
#else
	#define TJS_FAILED(x)				((x)<0)
#endif
#define TJS_SUCCEEDED(x)			(!TJS_FAILED(x))

static inline bool TJSIsObjectValid(tjs_error hr)
{
	// checks object validity by returning value of iTJSDispatch2::IsValid

	if(hr == TJS_S_TRUE) return true;  // mostly expected value for valid object
	if(hr == TJS_E_NOTIMPL) return true; // also valid for object which does not implement IsValid

	return false; // otherwise the object is not valid
}



//---------------------------------------------------------------------------
// tTJSNativeInstanceType
//---------------------------------------------------------------------------
enum tTJSNativeInstanceType
{
	nitClass,
	nitMethod,
	nitProperty
};
//---------------------------------------------------------------------------





//---------------------------------------------------------------------------
// tTJSNativeInstance
//---------------------------------------------------------------------------
class tTJSNativeInstance : public iTJSNativeInstance
{
public:
	virtual tjs_error TJS_INTF_METHOD Construct(tjs_int numparams,
		tTJSVariant **param, iTJSDispatch2 *tjs_obj) {return TJS_S_OK;}
	virtual void TJS_INTF_METHOD Invalidate() {;}
	virtual void TJS_INTF_METHOD Destruct() { delete this; }
	virtual ~tTJSNativeInstance() {;};
};
//---------------------------------------------------------------------------





//---------------------------------------------------------------------------
// tTJSNativeClassMethod
//---------------------------------------------------------------------------
typedef tjs_error (TJS_INTF_METHOD *tTJSNativeClassMethodCallback)
	(tTJSVariant *result,tjs_int numparams, tTJSVariant **param,
	iTJSDispatch2 *objthis);


class tTJSNativeClassMethod : public iTJSDispatch2 { };






//---------------------------------------------------------------------------
// tTJSNativeClassProperty
//---------------------------------------------------------------------------
typedef tjs_error (TJS_INTF_METHOD *tTJSNativeClassPropertyGetCallback)
	(tTJSVariant *result, iTJSDispatch2 *objthis);
typedef tjs_error (TJS_INTF_METHOD *tTJSNativeClassPropertySetCallback)
	(const tTJSVariant *param, iTJSDispatch2 *objthis);


class tTJSNativeClassProperty : public iTJSDispatch2 { };





//---------------------------------------------------------------------------
// tTJSNativeClassForPlugin : service class for plugins
//---------------------------------------------------------------------------
typedef iTJSNativeInstance * (TJS_INTF_METHOD *tTJSCreateNativeInstance)();


class tTJSNativeClass : public iTJSDispatch2 { };
class tTJSNativeClassForPlugin : public tTJSNativeClass { };





//---------------------------------------------------------------------------
// following macros are to be written in the constructor of child class
// to define native methods/properties.


#define TJS_NCM_REG_THIS classobj
#define TJS_NATIVE_SET_ClassID TJS_NATIVE_CLASSID_NAME = TJS_NCM_CLASSID;



#define TJS_GET_NATIVE_INSTANCE(varname, typename) \
		if(!objthis) return TJS_E_NATIVECLASSCRASH; \
		typename *varname; \
		{ \
			tjs_error hr; \
			hr = objthis->NativeInstanceSupport(TJS_NIS_GETINSTANCE, \
					TJS_NATIVE_CLASSID_NAME, (iTJSNativeInstance**)&varname); \
			if(TJS_FAILED(hr)) return TJS_E_NATIVECLASSCRASH; \
		}

#define TJS_GET_NATIVE_INSTANCE_OUTER(classname, varname, typename) \
		if(!objthis) return TJS_E_NATIVECLASSCRASH; \
		typename *varname; \
		{ \
			tjs_error hr; \
			hr = objthis->NativeInstanceSupport(TJS_NIS_GETINSTANCE, \
					classname::ClassID, (iTJSNativeInstance**)&varname); \
			if(TJS_FAILED(hr)) return TJS_E_NATIVECLASSCRASH; \
		}

#define TJS_BEGIN_NATIVE_MEMBERS(classname) \
	{ \
		static const tjs_char *__classname = TJS_W(#classname); \
		static tjs_int32 TJS_NCM_CLASSID = \
			TJSRegisterNativeClass(__classname); \
		TJSNativeClassSetClassID(TJS_NCM_REG_THIS, TJS_NCM_CLASSID); \
		TJS_NATIVE_SET_ClassID

#define TJS_BEGIN_NATIVE_METHOD_DECL(name) \
		struct NCM_##name { \
			static tjs_error TJS_INTF_METHOD \
			Process( tTJSVariant *result, \
				tjs_int numparams, tTJSVariant **param,	iTJSDispatch2 *objthis) {

#define TJS_END_NATIVE_METHOD_DECL_INT \
			} \
		};

#define TJS_END_NATIVE_METHOD_DECL(name) \
		TJS_END_NATIVE_METHOD_DECL_INT \
		TJSNativeClassRegisterNCM(TJS_NCM_REG_THIS, TJS_W(#name), \
		TJSCreateNativeClassMethod(NCM_##name::Process), __classname, nitMethod);

#define TJS_END_NATIVE_HIDDEN_METHOD_DECL(name) \
		TJS_END_NATIVE_METHOD_DECL_INT \
		TJSNativeClassRegisterNCM(TJS_NCM_REG_THIS, TJS_W(#name), \
		TJSCreateNativeClassMethod(NCM_##name::Process), __classname, nitMethod, \
		TJS_HIDDENMEMBER);

#define TJS_END_NATIVE_STATIC_METHOD_DECL(name) \
		TJS_END_NATIVE_METHOD_DECL_INT \
		TJSNativeClassRegisterNCM(TJS_NCM_REG_THIS, TJS_W(#name), \
		TJSCreateNativeClassMethod(NCM_##name::Process), __classname, nitMethod, \
		TJS_STATICMEMBER);

#define TJS_END_NATIVE_METHOD_DECL_OUTER(object, name) \
		TJS_END_NATIVE_METHOD_DECL_INT \
		TJSNativeClassRegisterNCM((object), TJS_W(#name), \
		TJSCreateNativeClassMethod(NCM_##name::Process), \
		(object)->GetClassName().c_str(), nitMethod);

#define TJS_DECL_EMPTY_FINALIZE_METHOD \
	TJS_BEGIN_NATIVE_METHOD_DECL(finalize) \
	{ return TJS_S_OK; } \
	TJS_END_NATIVE_METHOD_DECL(finalize)

#define TJS_NATIVE_CONSTRUCTOR_CALL_NATIVE_CONSTRUCTOR(varname, typename) \
				typename *varname; \
				{ \
					tjs_error hr; \
					hr = objthis->NativeInstanceSupport(TJS_NIS_GETINSTANCE, \
						TJS_NATIVE_CLASSID_NAME, \
						(iTJSNativeInstance**)&varname); \
					if(TJS_FAILED(hr)) return TJS_E_NATIVECLASSCRASH; \
					if(!varname) return TJS_E_NATIVECLASSCRASH; \
					hr = varname->Construct(numparams, param, objthis); \
					if(TJS_FAILED(hr)) return hr; \
				}

#define TJS_BEGIN_NATIVE_CONSTRUCTOR_DECL_NO_INSTANCE(classname) \
		struct NCM_##classname { \
			static tjs_error TJS_INTF_METHOD \
			Process(tTJSVariant *result, \
			tjs_int numparams, tTJSVariant **param,	iTJSDispatch2 *objthis) {

#define TJS_BEGIN_NATIVE_CONSTRUCTOR_DECL(varname, typename, classname) \
		TJS_BEGIN_NATIVE_CONSTRUCTOR_DECL_NO_INSTANCE(classname) \
		TJS_NATIVE_CONSTRUCTOR_CALL_NATIVE_CONSTRUCTOR(varname, typename)

#define TJS_END_NATIVE_CONSTRUCTOR_DECL(name) \
		TJS_END_NATIVE_METHOD_DECL_INT \
		TJSNativeClassRegisterNCM(TJS_NCM_REG_THIS, TJS_W(#name), \
		TJSCreateNativeClassConstructor(NCM_##name::Process), __classname, \
		nitMethod);

#define TJS_END_NATIVE_STATIC_CONSTRUCTOR_DECL(name) \
		TJS_END_NATIVE_METHOD_DECL_INT \
		TJSNativeClassRegisterNCM(TJS_NCM_REG_THIS, TJS_W(#name), \
		TJSCreateNativeClassConstructor(NCM_##name::Process), __classname, \
		nitMethod, TJS_STATICMEMBER);

#define TJS_BEGIN_NATIVE_PROP_DECL(name) \
		struct NCM_##name

#define TJS_END_NATIVE_PROP_DECL(name) \
		;TJSNativeClassRegisterNCM(TJS_NCM_REG_THIS, TJS_W(#name), \
		TJSCreateNativeClassProperty(NCM_##name::Get, NCM_##name::Set), \
		__classname, nitProperty);

#define TJS_END_NATIVE_PROP_DECL_OUTER(object, name) \
		;TJSNativeClassRegisterNCM((object), TJS_W(#name), \
		TJSCreateNativeClassProperty(NCM_##name::Get, NCM_##name::Set), \
		(object)->GetClassName().c_str(), nitProperty);

#define TJS_END_NATIVE_STATIC_PROP_DECL(name) \
		;TJSNativeClassRegisterNCM(TJS_NCM_REG_THIS, TJS_W(#name), \
		TJSCreateNativeClassProperty(NCM_##name::Get, NCM_##name::Set), \
		__classname, nitProperty, TJS_STATICMEMBER);

#define TJS_BEGIN_NATIVE_PROP_GETTER \
		static tjs_error TJS_INTF_METHOD Get(tTJSVariant *result, \
		iTJSDispatch2 *objthis) { \

#define TJS_END_NATIVE_PROP_GETTER \
		}

#define TJS_DENY_NATIVE_PROP_GETTER \
		static tjs_error TJS_INTF_METHOD Get(tTJSVariant *result, \
		iTJSDispatch2 *objthis) \
		{ return TJS_E_ACCESSDENYED; }

#define TJS_BEGIN_NATIVE_PROP_SETTER \
		static tjs_error TJS_INTF_METHOD Set(const tTJSVariant *param, \
		iTJSDispatch2 *objthis) { \

#define TJS_END_NATIVE_PROP_SETTER \
		}

#define TJS_DENY_NATIVE_PROP_SETTER \
		static tjs_error TJS_INTF_METHOD Set(const tTJSVariant *param, \
		iTJSDispatch2 *objthis) \
		{ return TJS_E_ACCESSDENYED; }

#define TJS_END_NATIVE_MEMBERS \
	}

#define TJS_PARAM_EXIST(num) (numparams>(num) ? param[num]->Type()!=tvtVoid : false)




//---------------------------------------------------------------------------
// tTJSVariantOctet
//---------------------------------------------------------------------------

#pragma pack(push, 4)
struct tTJSVariantOctet_S
{
	tjs_uint Length;
	tjs_int RefCount;
	tjs_uint8 *Data;
};
#pragma pack(pop)


//---------------------------------------------------------------------------
// tTJSVariant_S
//---------------------------------------------------------------------------
#ifdef __BORLANDC__
#pragma option push -b
#endif
enum tTJSVariantType
{
	tvtVoid,  // empty
	tvtObject,
	tvtString,
	tvtOctet,  // octet binary data
	tvtInteger,
	tvtReal
};
#ifdef __BORLANDC__
#pragma option pop
#endif


#pragma pack(push, 4)
class iTJSDispatch2;
struct tTJSVariantClosure_S
{
	iTJSDispatch2 *Object;
	iTJSDispatch2 *ObjThis;
};
class tTJSVariantClosure;

class tTJSVariantString;
class tTJSVariantOctet;
struct tTJSVariant_S
{
	//---- data members -----------------------------------------------------

	#define tTJSVariant_BITCOPY(a,b) \
	{\
		*(tTJSVariant_S*)&(a) = *(tTJSVariant_S*)&(b); \
	}

	union
	{
		tTJSVariantClosure_S Object;
		tTVInteger Integer;
		tTVReal Real;
		tTJSVariantString *String;
		tTJSVariantOctet *Octet;
	};
	tTJSVariantType vt;
};
#pragma pack(pop)


//---------------------------------------------------------------------------
// tTJSVariantClosure
//---------------------------------------------------------------------------


void TJSThrowNullAccess();



class tTJSVariantClosure : public tTJSVariantClosure_S
{
	// tTJSVariantClosure does not provide any function of object lifetime
	// namagement. ( AddRef and Release are provided but tTJSVariantClosure
	// has no responsibility for them )

public:
	tTJSVariantClosure() {;} // note that default constructor does nothing 

	tTJSVariantClosure(iTJSDispatch2 *obj, iTJSDispatch2 *objthis = NULL)
	{ Object = obj, ObjThis = objthis; }

	iTJSDispatch2 * SelectObjectNoAddRef()
		{ return ObjThis ? ObjThis : Object; }

public:

	bool operator == (const tTJSVariantClosure &rhs)
	{
		return Object == rhs.Object && ObjThis == rhs.ObjThis;
	}

	bool operator != (const tTJSVariantClosure &rhs)
	{
		return ! this->operator ==(rhs);
	}


	void AddRef()
	{
		if(Object) Object->AddRef();
		if(ObjThis) ObjThis->AddRef();
	}

	void Release()
	{
		if(Object) Object->Release();
		if(ObjThis) ObjThis->Release();
	}


	tjs_error
	FuncCall(tjs_uint32 flag, const tjs_char * membername, tjs_uint32 *hint,
		tTJSVariant *result,
		tjs_int numparams, tTJSVariant **param, iTJSDispatch2 *objthis) const
	{
		if(!Object) TJSThrowNullAccess();
		return Object->FuncCall(flag, membername, hint, result, numparams, param,
			ObjThis?ObjThis:(objthis?objthis:Object));
	}

	tjs_error
	FuncCallByNum(tjs_uint32 flag, tjs_int num, tTJSVariant *result,
		tjs_int numparams, tTJSVariant **param, iTJSDispatch2 *objthis) const
	{
		if(!Object) TJSThrowNullAccess();
		return Object->FuncCallByNum(flag, num, result, numparams, param,
			ObjThis?ObjThis:(objthis?objthis:Object));
	}

	tjs_error
	PropGet(tjs_uint32 flag, const tjs_char * membername, tjs_uint32 *hint,
		tTJSVariant *result,
		iTJSDispatch2 *objthis) const
	{
		if(!Object) TJSThrowNullAccess();
		return Object->PropGet(flag, membername, hint, result,
			ObjThis?ObjThis:(objthis?objthis:Object));
	}

	tjs_error
	PropGetByNum(tjs_uint32 flag, tjs_int num, tTJSVariant *result,
		iTJSDispatch2 *objthis) const
	{
		if(!Object) TJSThrowNullAccess();
		return Object->PropGetByNum(flag, num, result,
			ObjThis?ObjThis:(objthis?objthis:Object));
	}

	tjs_error
	PropSet(tjs_uint32 flag, const tjs_char *membername, tjs_uint32 *hint,
		const tTJSVariant *param,
		iTJSDispatch2 *objthis) const
	{
		if(!Object) TJSThrowNullAccess();
		return Object->PropSet(flag, membername, hint, param,
			ObjThis?ObjThis:(objthis?objthis:Object));
	}

	tjs_error
	PropSetByNum(tjs_uint32 flag, tjs_int num, const tTJSVariant *param,
		iTJSDispatch2 *objthis) const
	{
		if(!Object) TJSThrowNullAccess();
		return Object->PropSetByNum(flag, num, param,
			ObjThis?ObjThis:(objthis?objthis:Object));
	}

	tjs_error
	GetCount(tjs_int *result, const tjs_char *membername, tjs_uint32 *hint,
		iTJSDispatch2 *objthis) const
	{
		if(!Object) TJSThrowNullAccess();
		return Object->GetCount(result, membername, hint,
			ObjThis?ObjThis:(objthis?objthis:Object));
	}

	tjs_error
	GetCountByNum(tjs_int *result, tjs_int num, iTJSDispatch2 *objthis) const
	{
		if(!Object) TJSThrowNullAccess();
		return Object->GetCountByNum(result, num,
			ObjThis?ObjThis:(objthis?objthis:Object));
	}

	tjs_error
	PropSetByVS(tjs_uint32 flag, tTJSVariantString *membername,
		const tTJSVariant *param, iTJSDispatch2 *objthis) const
	{
		if(!Object) TJSThrowNullAccess();
		return Object->PropSetByVS(flag, membername, param,
			ObjThis?ObjThis:(objthis?objthis:Object));
	}

	tjs_error
	EnumMembers(tjs_uint32 flag, tTJSVariantClosure *callback,
		iTJSDispatch2 *objthis) const
	{
		if(!Object) TJSThrowNullAccess();
		return Object->EnumMembers(flag, callback,
			ObjThis?ObjThis:(objthis?objthis:Object));
	}

	tjs_error
	DeleteMember(tjs_uint32 flag, const tjs_char *membername, tjs_uint32 *hint,
		iTJSDispatch2 *objthis) const
	{
		if(!Object) TJSThrowNullAccess();
		return Object->DeleteMember(flag, membername, hint,
			ObjThis?ObjThis:(objthis?objthis:Object));
	}

	tjs_error
	DeleteMemberByNum(tjs_uint32 flag, tjs_int num, iTJSDispatch2 *objthis) const
	{
		if(!Object) TJSThrowNullAccess();
		return Object->DeleteMemberByNum(flag, num,
			ObjThis?ObjThis:(objthis?objthis:Object));
	}

	tjs_error
	Invalidate(tjs_uint32 flag, const tjs_char *membername, tjs_uint32 *hint,
		iTJSDispatch2 *objthis) const
	{
		if(!Object) TJSThrowNullAccess();
		return Object->Invalidate(flag, membername, hint,
			ObjThis?ObjThis:(objthis?objthis:Object));
	}

	tjs_error
	InvalidateByNum(tjs_uint32 flag, tjs_int num, iTJSDispatch2 *objthis) const
	{
		if(!Object) TJSThrowNullAccess();
		return Object->InvalidateByNum(flag, num,
			ObjThis?ObjThis:(objthis?objthis:Object));
	}

	tjs_error
	IsValid(tjs_uint32 flag, const tjs_char *membername, tjs_uint32 *hint,
		iTJSDispatch2 *objthis) const
	{
		if(!Object) TJSThrowNullAccess();
		return Object->IsValid(flag, membername, hint,
			ObjThis?ObjThis:(objthis?objthis:Object));
	}

	tjs_error
	IsValidByNum(tjs_uint32 flag, tjs_int num, iTJSDispatch2 *objthis) const
	{
		if(!Object) TJSThrowNullAccess();
		return Object->IsValidByNum(flag, num,
			ObjThis?ObjThis:(objthis?objthis:Object));
	}

	tjs_error
	CreateNew(tjs_uint32 flag, const tjs_char * membername, tjs_uint32 *hint,
		iTJSDispatch2 **result,
		tjs_int numparams, tTJSVariant **param,	iTJSDispatch2 *objthis) const
	{
		if(!Object) TJSThrowNullAccess();
		return Object->CreateNew(flag, membername, hint, result, numparams,
			param, ObjThis?ObjThis:(objthis?objthis:Object));
	}

	tjs_error
	CreateNewByNum(tjs_uint32 flag, tjs_int num, iTJSDispatch2 **result,
		tjs_int numparams, tTJSVariant **param,	iTJSDispatch2 *objthis) const
	{
		if(!Object) TJSThrowNullAccess();
		return Object->CreateNewByNum(flag, num, result, numparams, param,
			ObjThis?ObjThis:(objthis?objthis:Object));
	}

/*
	tjs_error
	Reserved1() { }
*/

	tjs_error
	IsInstanceOf(tjs_uint32 flag, const tjs_char *membername, tjs_uint32 *hint,
		const tjs_char *classname, iTJSDispatch2 *objthis) const
	{
		if(!Object) TJSThrowNullAccess();
		return Object->IsInstanceOf(flag, membername, hint, classname,
			ObjThis?ObjThis:(objthis?objthis:Object));
	}

	tjs_error
	IsInstanceOf(tjs_uint32 flag, tjs_int num, tjs_char *classname,
		iTJSDispatch2 *objthis) const
	{
		if(!Object) TJSThrowNullAccess();
		return Object->IsInstanceOfByNum(flag, num, classname,
			ObjThis?ObjThis:(objthis?objthis:Object));
	}

	tjs_error
	Operation(tjs_uint32 flag, const tjs_char *membername, tjs_uint32 *hint,
		tTJSVariant *result, const tTJSVariant *param,	iTJSDispatch2 *objthis) const
	{
		if(!Object) TJSThrowNullAccess();
		return Object->Operation(flag, membername, hint, result, param,
			ObjThis?ObjThis:(objthis?objthis:Object));
	}

	tjs_error
	OperationByNum(tjs_uint32 flag, tjs_int num, tTJSVariant *result,
		const tTJSVariant *param,	iTJSDispatch2 *objthis) const
	{
		if(!Object) TJSThrowNullAccess();
		return Object->OperationByNum(flag, num, result, param,
			ObjThis?ObjThis:(objthis?objthis:Object));
	}

/*
	tjs_error
	Reserved2() { }
*/

/*
	tjs_error
	Reserved3() { }
*/

};






//---------------------------------------------------------------------------
// iTJSTextStream - used by Array.save/load Dictionaty.save/load
//---------------------------------------------------------------------------
class tTJSString;
class iTJSTextReadStream
{
public:
	virtual tjs_uint TJS_INTF_METHOD Read(tTJSString & targ, tjs_uint size) = 0;
	virtual void TJS_INTF_METHOD Destruct() = 0; // must delete itself
};
//---------------------------------------------------------------------------
class iTJSTextWriteStream
{
public:
	virtual void TJS_INTF_METHOD Write(const tTJSString & targ) = 0;
	virtual void TJS_INTF_METHOD Destruct() = 0; // must delete itself
};
//---------------------------------------------------------------------------
extern iTJSTextReadStream * (*TJSCreateTextStreamForRead)(const tTJSString &name,
	const tTJSString &modestr);
extern iTJSTextWriteStream * (*TJSCreateTextStreamForWrite)(const tTJSString &name,
	const tTJSString &modestr);
//---------------------------------------------------------------------------






//---------------------------------------------------------------------------
// tTJSBinaryStream constants
//---------------------------------------------------------------------------
#define TJS_BS_READ 0
#define TJS_BS_WRITE 1
#define TJS_BS_APPEND 2
#define TJS_BS_UPDATE 3

#define TJS_BS_ACCESS_MASK 0x0f

#define TJS_BS_SEEK_SET 0
#define TJS_BS_SEEK_CUR 1
#define TJS_BS_SEEK_END 2
//---------------------------------------------------------------------------






//---------------------------------------------------------------------------
// tTJSDispatch
//---------------------------------------------------------------------------
/*
	tTJSDispatch is a base class that implements iTJSDispatch2, and every methods.
	most methods are maked as simply returning "TJS_E_NOTIMPL";
	methods, those access the object by index, call another methods that access
	the object by string.
*/
/*
#define TJS_SELECT_OBJTHIS(__closure__, __override__) \
	((__closure__).ObjThis?((__override__)?(__override__):(__closure__).ObjThis):(__override__))
*/
#define TJS_SELECT_OBJTHIS(__closure__, __override__) \
	((__closure__).ObjThis?(__closure__).ObjThis:(__override__))

class tTJSDispatch : public iTJSDispatch2
{
	virtual void BeforeDestruction(void) {;}
	bool BeforeDestructionCalled;
		// BeforeDestruction will be certainly called before object destruction
private:
	tjs_uint RefCount;
public:
	tTJSDispatch();
	virtual ~tTJSDispatch();

//	bool DestructionTrace;

public:
	tjs_uint TJS_INTF_METHOD  AddRef(void);
	tjs_uint TJS_INTF_METHOD  Release(void);

protected:
	tjs_uint GetRefCount() { return RefCount; }

public:
	tjs_error TJS_INTF_METHOD
	FuncCall(
		tjs_uint32 flag,
		const tjs_char * membername,
		tjs_uint32 *hint,
		tTJSVariant *result,
		tjs_int numparams,
		tTJSVariant **param,
		iTJSDispatch2 *objthis
		)
	{
		return membername?TJS_E_MEMBERNOTFOUND:TJS_E_NOTIMPL;
	}

	tjs_error TJS_INTF_METHOD
	FuncCallByNum(
		tjs_uint32 flag,
		tjs_int num,
		tTJSVariant *result,
		tjs_int numparams,
		tTJSVariant **param,
		iTJSDispatch2 *objthis
		);

	tjs_error TJS_INTF_METHOD
	PropGet(
		tjs_uint32 flag,
		const tjs_char * membername,
		tjs_uint32 *hint,
		tTJSVariant *result,
		iTJSDispatch2 *objthis
		)
	{
		return membername?TJS_E_MEMBERNOTFOUND:TJS_E_NOTIMPL;
	}

	tjs_error TJS_INTF_METHOD
	PropGetByNum(
		tjs_uint32 flag,
		tjs_int num,
		tTJSVariant *result,
		iTJSDispatch2 *objthis
		);

	tjs_error TJS_INTF_METHOD
	PropSet(
		tjs_uint32 flag,
		const tjs_char *membername,
		tjs_uint32 *hint,
		const tTJSVariant *param,
		iTJSDispatch2 *objthis
		)
	{
		return membername?TJS_E_MEMBERNOTFOUND:TJS_E_NOTIMPL;
	}

	tjs_error TJS_INTF_METHOD
	PropSetByNum(
		tjs_uint32 flag,
		tjs_int num,
		const tTJSVariant *param,
		iTJSDispatch2 *objthis
		);
	
	tjs_error TJS_INTF_METHOD
	GetCount(
		tjs_int *result,
		const tjs_char *membername,
		tjs_uint32 *hint,
		iTJSDispatch2 *objthis
		)
	{
		return TJS_E_NOTIMPL;
	}

	tjs_error TJS_INTF_METHOD
	GetCountByNum(
		tjs_int *result,
		tjs_int num,
		iTJSDispatch2 *objthis
		);


	tjs_error TJS_INTF_METHOD
	PropSetByVS(tjs_uint32 flag, tTJSVariantString *membername,
		const tTJSVariant *param, iTJSDispatch2 *objthis)
	{
		return TJS_E_NOTIMPL;
	}

	tjs_error TJS_INTF_METHOD
	EnumMembers(tjs_uint32 flag, tTJSVariantClosure *callback, iTJSDispatch2 *objthis)
	{
		return TJS_E_NOTIMPL;
	}

	tjs_error TJS_INTF_METHOD
	DeleteMember(
		tjs_uint32 flag,
		const tjs_char *membername,
		tjs_uint32 *hint,
		iTJSDispatch2 *objthis
		)
	{
		return membername?TJS_E_MEMBERNOTFOUND:TJS_E_NOTIMPL;
	}

	tjs_error TJS_INTF_METHOD
	DeleteMemberByNum(
		tjs_uint32 flag,
		tjs_int num,
		iTJSDispatch2 *objthis
		);

	tjs_error TJS_INTF_METHOD
	Invalidate(
		tjs_uint32 flag,
		const tjs_char *membername,
		tjs_uint32 *hint,
		iTJSDispatch2 *objthis
		)
	{
		return membername?TJS_E_MEMBERNOTFOUND:TJS_E_NOTIMPL;
	}

	tjs_error TJS_INTF_METHOD
	InvalidateByNum(
		tjs_uint32 flag,
		tjs_int num,
		iTJSDispatch2 *objthis
		);

	tjs_error TJS_INTF_METHOD
	IsValid(
		tjs_uint32 flag,
		const tjs_char *membername,
		tjs_uint32 *hint,
		iTJSDispatch2 *objthis
		)
	{
		return membername?TJS_E_MEMBERNOTFOUND:TJS_E_NOTIMPL;
	}

	tjs_error TJS_INTF_METHOD
	IsValidByNum(
		tjs_uint32 flag,
		tjs_int num,
		iTJSDispatch2 *objthis
		);

	tjs_error TJS_INTF_METHOD
	CreateNew(
		tjs_uint32 flag,
		const tjs_char * membername,
		tjs_uint32 *hint,
		iTJSDispatch2 **result,
		tjs_int numparams,
		tTJSVariant **param,
		iTJSDispatch2 *objthis
		)
	{
		return membername?TJS_E_MEMBERNOTFOUND:TJS_E_NOTIMPL;
	}

	tjs_error TJS_INTF_METHOD
	CreateNewByNum(
		tjs_uint32 flag,
		tjs_int num,
		iTJSDispatch2 **result,
		tjs_int numparams,
		tTJSVariant **param,
		iTJSDispatch2 *objthis
		);

	tjs_error TJS_INTF_METHOD
	Reserved1(
		)
	{
		return TJS_E_NOTIMPL;
	}


	tjs_error TJS_INTF_METHOD
	IsInstanceOf(
		tjs_uint32 flag,
		const tjs_char *membername,
		tjs_uint32 *hint,
		const tjs_char *classname,
		iTJSDispatch2 *objthis
		)
	{
		return membername?TJS_E_MEMBERNOTFOUND:TJS_E_NOTIMPL;
	}

	tjs_error TJS_INTF_METHOD
	IsInstanceOfByNum(
		tjs_uint32 flag,
		tjs_int num,
		const tjs_char *classname,
		iTJSDispatch2 *objthis
		);

	tjs_error TJS_INTF_METHOD
	Operation(
		tjs_uint32 flag,
		const tjs_char *membername,
		tjs_uint32 *hint,
		tTJSVariant *result,
		const tTJSVariant *param,
		iTJSDispatch2 *objthis
		);

	tjs_error TJS_INTF_METHOD
	OperationByNum(
		tjs_uint32 flag,
		tjs_int num,
		tTJSVariant *result,
		const tTJSVariant *param,
		iTJSDispatch2 *objthis
		);


	tjs_error TJS_INTF_METHOD
	NativeInstanceSupport(
		tjs_uint32 flag,
		tjs_int32 classid,
		iTJSNativeInstance **pointer
		)
	{
		return TJS_E_NOTIMPL;
	}

	tjs_error TJS_INTF_METHOD
	ClassInstanceInfo(
		tjs_uint32 flag,
		tjs_uint num,
		tTJSVariant *value
		)
	{
		return TJS_E_NOTIMPL;
	}

	tjs_error TJS_INTF_METHOD
	Reserved2(
		)
	{
		return TJS_E_NOTIMPL;
	}

	tjs_error TJS_INTF_METHOD
	Reserved3(
		)
	{
		return TJS_E_NOTIMPL;
	}


};
//---------------------------------------------------------------------------


#ifdef __BORLANDC__
#pragma warn -8027
#endif

#define ZRVL_IMPORT_FUNC_DECL(_type) extern "C" _type __declspec(dllimport) __stdcall

ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0000_Export_Func(tTJSVariant *, iTJSDispatch2 *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0001_Export_Func(tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0002_Export_Func(tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0003_Export_Func(tTJSVariant *, iTJSDispatch2 *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0004_Export_Func(tTJSVariant *, iTJSDispatch2 *,iTJSDispatch2 *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0005_Export_Func(tTJSVariant *, const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0006_Export_Func(tTJSVariant *, const tTJSString &);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0007_Export_Func(tTJSVariant *, const tjs_nchar *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0008_Export_Func(tTJSVariant *, const tjs_uint8 *,tjs_uint);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0009_Export_Func(tTJSVariant *, bool);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_000A_Export_Func(tTJSVariant *, tjs_int32);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_000B_Export_Func(tTJSVariant *, tjs_int64);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_000C_Export_Func(tTJSVariant *, tjs_real);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_000D_Export_Func(tTJSVariant *, const tjs_uint8 * *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_000E_Export_Func(tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantType) Zrvl_000F_Export_Func(tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0010_Export_Func(tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantClosure &) Zrvl_0011_Export_Func(tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0012_Export_Func(tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(iTJSDispatch2 *) Zrvl_0013_Export_Func(tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0014_Export_Func(tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(tjs_uint32 *) Zrvl_0015_Export_Func(tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0016_Export_Func(tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0017_Export_Func(tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0018_Export_Func(tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant &) Zrvl_0019_Export_Func(tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_001A_Export_Func(tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant &) Zrvl_001B_Export_Func(tTJSVariant *, iTJSDispatch2 *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant &) Zrvl_001C_Export_Func(tTJSVariant *, iTJSDispatch2 *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant &) Zrvl_001D_Export_Func(tTJSVariant *, iTJSDispatch2 *,iTJSDispatch2 *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant &) Zrvl_001E_Export_Func(tTJSVariant *, tTJSVariantClosure);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant &) Zrvl_001F_Export_Func(tTJSVariant *, tTJSVariantString *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant &) Zrvl_0020_Export_Func(tTJSVariant *, tTJSVariantOctet *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant &) Zrvl_0021_Export_Func(tTJSVariant *, const tTJSString &);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant &) Zrvl_0022_Export_Func(tTJSVariant *, const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant &) Zrvl_0023_Export_Func(tTJSVariant *, const tjs_nchar *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant &) Zrvl_0024_Export_Func(tTJSVariant *, bool);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant &) Zrvl_0025_Export_Func(tTJSVariant *, tjs_int32);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant &) Zrvl_0026_Export_Func(tTJSVariant *, const tTVInteger);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant &) Zrvl_0027_Export_Func(tTJSVariant *, tjs_real);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0028_Export_Func(tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0029_Export_Func(tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_002A_Export_Func(tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_002B_Export_Func(tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_002C_Export_Func(tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_002D_Export_Func(tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_002E_Export_Func(tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_002F_Export_Func(tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0030_Export_Func(tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0031_Export_Func(tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0032_Export_Func(tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0033_Export_Func(tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0034_Export_Func(tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0035_Export_Func(tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0036_Export_Func(tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0037_Export_Func(tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0038_Export_Func(tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0039_Export_Func(tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_003A_Export_Func(tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_003B_Export_Func(tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(bool) Zrvl_003C_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(bool) Zrvl_003D_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(bool) Zrvl_003E_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(bool) Zrvl_003F_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(bool) Zrvl_0040_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(bool) Zrvl_0041_Export_Func(const tTJSVariant *, const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(iTJSDispatch2 *) Zrvl_0042_Export_Func(const tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(iTJSDispatch2 *) Zrvl_0043_Export_Func(const tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(iTJSDispatch2 *) Zrvl_0044_Export_Func(const tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(iTJSDispatch2 *) Zrvl_0045_Export_Func(const tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantClosure &) Zrvl_0046_Export_Func(const tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantString *) Zrvl_0047_Export_Func(const tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantString *) Zrvl_0048_Export_Func(const tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(const tjs_char *) Zrvl_0049_Export_Func(const tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantOctet *) Zrvl_004A_Export_Func(const tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantOctet *) Zrvl_004B_Export_Func(const tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(tTVInteger) Zrvl_004C_Export_Func(const tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_004D_Export_Func(const tTJSVariant *, tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(tTVInteger) Zrvl_004E_Export_Func(const tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(bool) Zrvl_004F_Export_Func(const tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(tjs_int) Zrvl_0050_Export_Func(const tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(tTVReal) Zrvl_0051_Export_Func(const tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(tTVReal) Zrvl_0052_Export_Func(const tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_0053_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_0054_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_0055_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_0056_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_0057_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_0058_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_0059_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_005A_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_005B_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_005C_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_005D_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_005E_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_005F_Export_Func(const tTJSVariant *, tjs_int);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_0060_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_0061_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_0062_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_0063_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_0064_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_0065_Export_Func(const tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_0066_Export_Func(const tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_0067_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_0068_Export_Func(const tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_0069_Export_Func(const tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariant) Zrvl_006A_Export_Func(const tTJSVariant *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(void *) Zrvl_006B_Export_Func(size_t);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_006C_Export_Func(void *);
ZRVL_IMPORT_FUNC_DECL(void *) Zrvl_006D_Export_Func(size_t);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_006E_Export_Func(void *);
ZRVL_IMPORT_FUNC_DECL(void *) Zrvl_006F_Export_Func(size_t,void *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0070_Export_Func(tTJSVariantOctet *, const tjs_uint8 *,tjs_uint);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0071_Export_Func(tTJSVariantOctet *, const tjs_uint8 *,tjs_uint,const tjs_uint8 *,tjs_uint);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0072_Export_Func(tTJSVariantOctet *, const tTJSVariantOctet *,const tTJSVariantOctet *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0073_Export_Func(tTJSVariantOctet *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0074_Export_Func(tTJSVariantOctet *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0075_Export_Func(tTJSVariantOctet *);
ZRVL_IMPORT_FUNC_DECL(tjs_uint) Zrvl_0076_Export_Func(const tTJSVariantOctet *);
ZRVL_IMPORT_FUNC_DECL(const tjs_uint8 *) Zrvl_0077_Export_Func(const tTJSVariantOctet *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0078_Export_Func(tTJSString *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0079_Export_Func(tTJSString *, const tTJSString &);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_007A_Export_Func(tTJSString *, tTJSVariantString *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_007B_Export_Func(tTJSString *, const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_007C_Export_Func(tTJSString *, const tjs_nchar *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_007D_Export_Func(tTJSString *, const tTJSStringBufferLength);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_007E_Export_Func(tTJSString *, tjs_char);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_007F_Export_Func(tTJSString *, const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0080_Export_Func(tTJSString *, const tTJSString &,int);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0081_Export_Func(tTJSString *, const tjs_char *,int);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0082_Export_Func(tTJSString *, tjs_int);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0083_Export_Func(tTJSString *);
ZRVL_IMPORT_FUNC_DECL(tTJSString &) Zrvl_0084_Export_Func(tTJSString *, const tTJSString &);
ZRVL_IMPORT_FUNC_DECL(tTJSString &) Zrvl_0085_Export_Func(tTJSString *, const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(tTJSString &) Zrvl_0086_Export_Func(tTJSString *, const tjs_nchar *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0087_Export_Func(tTJSString *, const tTJSString &);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0088_Export_Func(tTJSString *, const tTJSVariantString *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0089_Export_Func(tTJSString *, const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_008A_Export_Func(tTJSString *, tjs_char);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_008B_Export_Func(tTJSString *);
ZRVL_IMPORT_FUNC_DECL(tjs_char *) Zrvl_008C_Export_Func(tTJSString *, tjs_uint);
ZRVL_IMPORT_FUNC_DECL(tjs_char *) Zrvl_008D_Export_Func(tTJSString *, tjs_uint);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_008E_Export_Func(tTJSString *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_008F_Export_Func(tTJSString *, const tTJSString &,const tTJSString &,bool);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0090_Export_Func(tTJSString *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_0091_Export_Func(tTJSString *);
ZRVL_IMPORT_FUNC_DECL(tjs_uint32 *) Zrvl_0092_Export_Func(tTJSString *);
ZRVL_IMPORT_FUNC_DECL(tjs_char *) Zrvl_0093_Export_Func(tTJSString *);
ZRVL_IMPORT_FUNC_DECL(const tjs_char *) Zrvl_0094_Export_Func(const tTJSString *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantString *) Zrvl_0095_Export_Func(const tTJSString *);
ZRVL_IMPORT_FUNC_DECL(tjs_int64) Zrvl_0096_Export_Func(const tTJSString *);
ZRVL_IMPORT_FUNC_DECL(bool) Zrvl_0097_Export_Func(const tTJSString *, const tTJSString &);
ZRVL_IMPORT_FUNC_DECL(bool) Zrvl_0098_Export_Func(const tTJSString *, const tTJSString &);
ZRVL_IMPORT_FUNC_DECL(tjs_int) Zrvl_0099_Export_Func(const tTJSString *, const tTJSString &);
ZRVL_IMPORT_FUNC_DECL(bool) Zrvl_009A_Export_Func(const tTJSString *, const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(bool) Zrvl_009B_Export_Func(const tTJSString *, const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(tjs_int) Zrvl_009C_Export_Func(const tTJSString *, const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(bool) Zrvl_009D_Export_Func(const tTJSString *, const tTJSString &);
ZRVL_IMPORT_FUNC_DECL(bool) Zrvl_009E_Export_Func(const tTJSString *, const tTJSString &);
ZRVL_IMPORT_FUNC_DECL(tTJSString) Zrvl_009F_Export_Func(const tTJSString *, const tTJSString &);
ZRVL_IMPORT_FUNC_DECL(tTJSString) Zrvl_00A0_Export_Func(const tTJSString *, const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(tTJSString) Zrvl_00A1_Export_Func(const tTJSString *, tjs_char);
ZRVL_IMPORT_FUNC_DECL(tjs_char) Zrvl_00A2_Export_Func(const tTJSString *, tjs_uint);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00A3_Export_Func(const tTJSString *, tTJSString &);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00A4_Export_Func(const tTJSString *, tTJSString &);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00A5_Export_Func(const tTJSString *, tTJSString &);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00A6_Export_Func(const tTJSString *, tTJSString &);
ZRVL_IMPORT_FUNC_DECL(bool) Zrvl_00A7_Export_Func(const tTJSString *, const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(bool) Zrvl_00A8_Export_Func(const tTJSString *, const tTJSString &);
ZRVL_IMPORT_FUNC_DECL(tjs_int) Zrvl_00A9_Export_Func(const tTJSString *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00AA_Export_Func(const tTJSString *, tjs_nchar *,tjs_int);
ZRVL_IMPORT_FUNC_DECL(bool) Zrvl_00AB_Export_Func(const tTJSString *);
ZRVL_IMPORT_FUNC_DECL(tjs_int) Zrvl_00AC_Export_Func(const tTJSString *);
ZRVL_IMPORT_FUNC_DECL(tjs_int) Zrvl_00AD_Export_Func(const tTJSString *);
ZRVL_IMPORT_FUNC_DECL(tjs_char) Zrvl_00AE_Export_Func(const tTJSString *);
ZRVL_IMPORT_FUNC_DECL(void *) Zrvl_00AF_Export_Func(size_t);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00B0_Export_Func(void *);
ZRVL_IMPORT_FUNC_DECL(void *) Zrvl_00B1_Export_Func(size_t);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00B2_Export_Func(void *);
ZRVL_IMPORT_FUNC_DECL(void *) Zrvl_00B3_Export_Func(size_t,void *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00B4_Export_Func(tTJSVariantString *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00B5_Export_Func(tTJSVariantString *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00B6_Export_Func(tTJSVariantString *, const tjs_char *,tjs_int);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00B7_Export_Func(tTJSVariantString *, const tjs_nchar *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00B8_Export_Func(tTJSVariantString *, tjs_uint);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00B9_Export_Func(tTJSVariantString *, const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00BA_Export_Func(tTJSVariantString *, tjs_uint);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00BB_Export_Func(tTJSVariantString *, const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00BC_Export_Func(tTJSVariantString *, const tjs_char *,tjs_int);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantString *) Zrvl_00BD_Export_Func(tTJSVariantString *);
ZRVL_IMPORT_FUNC_DECL(tjs_uint32 *) Zrvl_00BE_Export_Func(tTJSVariantString *);
ZRVL_IMPORT_FUNC_DECL(const tjs_char *) Zrvl_00BF_Export_Func(const tTJSVariantString *);
ZRVL_IMPORT_FUNC_DECL(tjs_int) Zrvl_00C0_Export_Func(const tTJSVariantString *);
ZRVL_IMPORT_FUNC_DECL(tTVInteger) Zrvl_00C1_Export_Func(const tTJSVariantString *);
ZRVL_IMPORT_FUNC_DECL(tTVReal) Zrvl_00C2_Export_Func(const tTJSVariantString *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00C3_Export_Func(const tTJSVariantString *, tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(tjs_int) Zrvl_00C4_Export_Func(const tTJSVariantString *);
ZRVL_IMPORT_FUNC_DECL(tjs_int) Zrvl_00C5_Export_Func(const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(tjs_char *) Zrvl_00C6_Export_Func(tjs_int,tjs_char *);
ZRVL_IMPORT_FUNC_DECL(tjs_char *) Zrvl_00C7_Export_Func(tjs_int64,tjs_char *);
ZRVL_IMPORT_FUNC_DECL(tjs_int) Zrvl_00C8_Export_Func(const tjs_char *,const tjs_char *,size_t);
ZRVL_IMPORT_FUNC_DECL(tjs_int) Zrvl_00C9_Export_Func(const tjs_char *,const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00CA_Export_Func(tjs_char *,const tjs_char *,size_t);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00CB_Export_Func(tjs_char *,const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(size_t) Zrvl_00CC_Export_Func(const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(tjs_char *) Zrvl_00CD_Export_Func(tjs_uint);
ZRVL_IMPORT_FUNC_DECL(tjs_char *) Zrvl_00CE_Export_Func(tjs_char *,tjs_uint);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00CF_Export_Func(tjs_char *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantString *) Zrvl_00D0_Export_Func(const tjs_char *,const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantString *) Zrvl_00D1_Export_Func(const tjs_char *,tjs_int);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantString *) Zrvl_00D2_Export_Func(const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantString *) Zrvl_00D3_Export_Func(const tjs_nchar *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantString *) Zrvl_00D4_Export_Func(const tjs_uint8 * *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantString *) Zrvl_00D5_Export_Func(tjs_uint);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantString *) Zrvl_00D6_Export_Func(tTJSVariantString *,const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantString *) Zrvl_00D7_Export_Func(tTJSVariantString *,const tTJSVariantString *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantString *) Zrvl_00D8_Export_Func(const tjs_char *,tjs_uint,tTJSVariant * *);
ZRVL_IMPORT_FUNC_DECL(const tjs_char *) Zrvl_00D9_Export_Func(tTJSVariantType);
ZRVL_IMPORT_FUNC_DECL(tTJSString) Zrvl_00DA_Export_Func(const tTJSVariant &,tjs_int);
ZRVL_IMPORT_FUNC_DECL(tTJSString) Zrvl_00DB_Export_Func(const tTJSVariant &);
ZRVL_IMPORT_FUNC_DECL(void *) Zrvl_00DC_Export_Func(tjs_uint,tjs_uint);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00DD_Export_Func(void *);
ZRVL_IMPORT_FUNC_DECL(tjs_uint32) Zrvl_00DE_Export_Func(tjs_real);
ZRVL_IMPORT_FUNC_DECL(tTJSString) Zrvl_00DF_Export_Func(const tjs_char *,const tTJSString &);
ZRVL_IMPORT_FUNC_DECL(tTJSString) Zrvl_00E0_Export_Func(tjs_uint32,int);
ZRVL_IMPORT_FUNC_DECL(tjs_int32) Zrvl_00E1_Export_Func(const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(tjs_int32) Zrvl_00E2_Export_Func(const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(const tjs_char *) Zrvl_00E3_Export_Func(tjs_int32);
ZRVL_IMPORT_FUNC_DECL(tTJSNativeClassMethod *) Zrvl_00E4_Export_Func(tTJSNativeClassMethodCallback);
ZRVL_IMPORT_FUNC_DECL(tTJSNativeClassMethod *) Zrvl_00E5_Export_Func(tTJSNativeClassMethodCallback);
ZRVL_IMPORT_FUNC_DECL(tTJSNativeClassProperty *) Zrvl_00E6_Export_Func(tTJSNativeClassPropertyGetCallback,tTJSNativeClassPropertySetCallback);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00E7_Export_Func(tTJSNativeClass *,const tjs_char *,iTJSDispatch2 *,const tjs_char *,tTJSNativeInstanceType,tjs_uint32);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00E8_Export_Func(tTJSNativeClass *,tjs_int32);
ZRVL_IMPORT_FUNC_DECL(tTJSNativeClassForPlugin *) Zrvl_00E9_Export_Func(const ttstr &,tTJSCreateNativeInstance);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00EA_Export_Func();
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00EB_Export_Func();
ZRVL_IMPORT_FUNC_DECL(tTJSVariantOctet *) Zrvl_00EC_Export_Func(const tjs_uint8 *,tjs_uint);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantOctet *) Zrvl_00ED_Export_Func(const tjs_uint8 *,tjs_uint,const tjs_uint8 *,tjs_uint);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantOctet *) Zrvl_00EE_Export_Func(const tTJSVariantOctet *,const tTJSVariantOctet *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantOctet *) Zrvl_00EF_Export_Func(const tjs_uint8 * *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00F0_Export_Func(tTJSVariantOctet *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantString *) Zrvl_00F1_Export_Func(const tTJSVariantOctet *);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantString *) Zrvl_00F2_Export_Func(const tTJSVariantClosure &);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantString *) Zrvl_00F3_Export_Func(tjs_int64);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantString *) Zrvl_00F4_Export_Func(tjs_real);
ZRVL_IMPORT_FUNC_DECL(tTJSVariantString *) Zrvl_00F5_Export_Func(tjs_real);
ZRVL_IMPORT_FUNC_DECL(tTVInteger) Zrvl_00F6_Export_Func(const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(tTVReal) Zrvl_00F7_Export_Func(const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(iTJSDispatch2 *) Zrvl_00F8_Export_Func(iTJSDispatch2 * *);
ZRVL_IMPORT_FUNC_DECL(tjs_int) Zrvl_00F9_Export_Func(iTJSDispatch2 *);
ZRVL_IMPORT_FUNC_DECL(tjs_int) Zrvl_00FA_Export_Func(iTJSDispatch2 *,tTJSVariant *,tjs_uint,tjs_int);
ZRVL_IMPORT_FUNC_DECL(iTJSDispatch2 *) Zrvl_00FB_Export_Func(iTJSDispatch2 * *);
ZRVL_IMPORT_FUNC_DECL(ttstr) Zrvl_00FC_Export_Func(const tjs_char *);
ZRVL_IMPORT_FUNC_DECL(ttstr) Zrvl_00FD_Export_Func(const ttstr &);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00FE_Export_Func(tjs_int,tTJSVariant &,const tTJSVariant *);
ZRVL_IMPORT_FUNC_DECL(void) Zrvl_00FF_Export_Func();
ZRVL_IMPORT_FUNC_DECL(iTJSDispatch2 *) Zrvl_0100_Export_Func();


//---------------------------------------------------------------------------
// tTJSVariantString
//---------------------------------------------------------------------------

class tTJSVariantString : protected tTJSVariantString_S
{
	// do not create an instance of this class directly.

public:
	void AddRef()
	{
		Zrvl_00B4_Export_Func(this);
	}

	void Release()
	{
		Zrvl_00B5_Export_Func(this);
	}

	void SetString(const tjs_char * ref , tjs_int maxlen = - 1)
	{
		Zrvl_00B6_Export_Func(this, ref, maxlen);
	}

	void SetString(const tjs_nchar * ref)
	{
		Zrvl_00B7_Export_Func(this, ref);
	}

	void AllocBuffer(tjs_uint len)
	{
		Zrvl_00B8_Export_Func(this, len);
	}

	void ResetString(const tjs_char * ref)
	{
		Zrvl_00B9_Export_Func(this, ref);
	}

	void AppendBuffer(tjs_uint applen)
	{
		Zrvl_00BA_Export_Func(this, applen);
	}

	void Append(const tjs_char * str)
	{
		Zrvl_00BB_Export_Func(this, str);
	}

	void Append(const tjs_char * str , tjs_int applen)
	{
		Zrvl_00BC_Export_Func(this, str, applen);
	}

	tTJSVariantString * FixLength()
	{
		return Zrvl_00BD_Export_Func(this);
	}

	tjs_uint32 * GetHint()
	{
		return Zrvl_00BE_Export_Func(this);
	}

	operator const tjs_char *() const
	{
		return Zrvl_00BF_Export_Func(this);
	}

	tjs_int GetLength() const
	{
		return Zrvl_00C0_Export_Func(this);
	}

	tTVInteger ToInteger() const
	{
		return Zrvl_00C1_Export_Func(this);
	}

	tTVReal ToReal() const
	{
		return Zrvl_00C2_Export_Func(this);
	}

	void ToNumber(tTJSVariant & dest) const
	{
		Zrvl_00C3_Export_Func(this, dest);
	}

	tjs_int GetRefCount() const
	{
		return Zrvl_00C4_Export_Func(this);
	}

};
//---------------------------------------------------------------------------
// tTJSVariantOctet
//---------------------------------------------------------------------------

class tTJSVariantOctet : protected tTJSVariantOctet_S
{
	// do not create an instance of this class directly.

public:
	tTJSVariantOctet(const tjs_uint8 * data , tjs_uint length)
	{
		Zrvl_0070_Export_Func(this, data, length);
	}

	tTJSVariantOctet(const tjs_uint8 * data1 , tjs_uint len1 , const tjs_uint8 * data2 , tjs_uint len2)
	{
		Zrvl_0071_Export_Func(this, data1, len1, data2, len2);
	}

	tTJSVariantOctet(const tTJSVariantOctet * o1 , const tTJSVariantOctet * o2)
	{
		Zrvl_0072_Export_Func(this, o1, o2);
	}

	~ tTJSVariantOctet()
	{
		Zrvl_0073_Export_Func(this);
	}

	void AddRef()
	{
		Zrvl_0074_Export_Func(this);
	}

	void Release()
	{
		Zrvl_0075_Export_Func(this);
	}

	tjs_uint GetLength() const
	{
		return Zrvl_0076_Export_Func(this);
	}

	const tjs_uint8 * GetData() const
	{
		return Zrvl_0077_Export_Func(this);
	}

};
//---------------------------------------------------------------------------
// tTJSVariant
//---------------------------------------------------------------------------

class tTJSVariant : protected tTJSVariant_S
{

public:
	void ChangeClosureObjThis(iTJSDispatch2 * objthis)
	{
		Zrvl_0000_Export_Func(this, objthis);
	}

	tTJSVariant()
	{
		Zrvl_0001_Export_Func(this);
	}

	tTJSVariant(const tTJSVariant & ref)
	{
		Zrvl_0002_Export_Func(this, ref);
	}

	tTJSVariant(iTJSDispatch2 * ref)
	{
		Zrvl_0003_Export_Func(this, ref);
	}

	tTJSVariant(iTJSDispatch2 * obj , iTJSDispatch2 * objthis)
	{
		Zrvl_0004_Export_Func(this, obj, objthis);
	}

	tTJSVariant(const tjs_char * ref)
	{
		Zrvl_0005_Export_Func(this, ref);
	}

	tTJSVariant(const tTJSString & ref)
	{
		Zrvl_0006_Export_Func(this, ref);
	}

	tTJSVariant(const tjs_nchar * ref)
	{
		Zrvl_0007_Export_Func(this, ref);
	}

	tTJSVariant(const tjs_uint8 * ref , tjs_uint len)
	{
		Zrvl_0008_Export_Func(this, ref, len);
	}

	tTJSVariant(bool ref)
	{
		Zrvl_0009_Export_Func(this, ref);
	}

	tTJSVariant(tjs_int32 ref)
	{
		Zrvl_000A_Export_Func(this, ref);
	}

	tTJSVariant(tjs_int64 ref)
	{
		Zrvl_000B_Export_Func(this, ref);
	}

	tTJSVariant(tjs_real ref)
	{
		Zrvl_000C_Export_Func(this, ref);
	}

	tTJSVariant(const tjs_uint8 * * src)
	{
		Zrvl_000D_Export_Func(this, src);
	}

	~ tTJSVariant()
	{
		Zrvl_000E_Export_Func(this);
	}

	tTJSVariantType Type()
	{
		return Zrvl_000F_Export_Func(this);
	}

	void Clear()
	{
		Zrvl_0010_Export_Func(this);
	}

	tTJSVariantClosure & AsObjectClosure()
	{
		return Zrvl_0011_Export_Func(this);
	}

	void ToObject()
	{
		Zrvl_0012_Export_Func(this);
	}

	operator iTJSDispatch2 *()
	{
		return Zrvl_0013_Export_Func(this);
	}

	void ToString()
	{
		Zrvl_0014_Export_Func(this);
	}

	tjs_uint32 * GetHint()
	{
		return Zrvl_0015_Export_Func(this);
	}

	void ToOctet()
	{
		Zrvl_0016_Export_Func(this);
	}

	void ToInteger()
	{
		Zrvl_0017_Export_Func(this);
	}

	void ToReal()
	{
		Zrvl_0018_Export_Func(this);
	}

	tTJSVariant & operator =(const tTJSVariant & ref)
	{
		return Zrvl_0019_Export_Func(this, ref);
	}

	void CopyRef(const tTJSVariant & ref)
	{
		Zrvl_001A_Export_Func(this, ref);
	}

	tTJSVariant & operator =(iTJSDispatch2 * ref)
	{
		return Zrvl_001B_Export_Func(this, ref);
	}

	tTJSVariant & SetObject(iTJSDispatch2 * ref)
	{
		return Zrvl_001C_Export_Func(this, ref);
	}

	tTJSVariant & SetObject(iTJSDispatch2 * object , iTJSDispatch2 * objthis)
	{
		return Zrvl_001D_Export_Func(this, object, objthis);
	}

	tTJSVariant & operator =(tTJSVariantClosure ref)
	{
		return Zrvl_001E_Export_Func(this, ref);
	}

	tTJSVariant & operator =(tTJSVariantString * ref)
	{
		return Zrvl_001F_Export_Func(this, ref);
	}

	tTJSVariant & operator =(tTJSVariantOctet * ref)
	{
		return Zrvl_0020_Export_Func(this, ref);
	}

	tTJSVariant & operator =(const tTJSString & ref)
	{
		return Zrvl_0021_Export_Func(this, ref);
	}

	tTJSVariant & operator =(const tjs_char * ref)
	{
		return Zrvl_0022_Export_Func(this, ref);
	}

	tTJSVariant & operator =(const tjs_nchar * ref)
	{
		return Zrvl_0023_Export_Func(this, ref);
	}

	tTJSVariant & operator =(bool ref)
	{
		return Zrvl_0024_Export_Func(this, ref);
	}

	tTJSVariant & operator =(tjs_int32 ref)
	{
		return Zrvl_0025_Export_Func(this, ref);
	}

	tTJSVariant & operator =(const tTVInteger ref)
	{
		return Zrvl_0026_Export_Func(this, ref);
	}

	tTJSVariant & operator =(tjs_real ref)
	{
		return Zrvl_0027_Export_Func(this, ref);
	}

	void logicalorequal(const tTJSVariant & rhs)
	{
		Zrvl_0028_Export_Func(this, rhs);
	}

	void logicalandequal(const tTJSVariant & rhs)
	{
		Zrvl_0029_Export_Func(this, rhs);
	}

	void operator |=(const tTJSVariant & rhs)
	{
		Zrvl_002A_Export_Func(this, rhs);
	}

	void increment()
	{
		Zrvl_002B_Export_Func(this);
	}

	void decrement()
	{
		Zrvl_002C_Export_Func(this);
	}

	void operator ^=(const tTJSVariant & rhs)
	{
		Zrvl_002D_Export_Func(this, rhs);
	}

	void operator &=(const tTJSVariant & rhs)
	{
		Zrvl_002E_Export_Func(this, rhs);
	}

	void operator >>=(const tTJSVariant & rhs)
	{
		Zrvl_002F_Export_Func(this, rhs);
	}

	void rbitshiftequal(const tTJSVariant & rhs)
	{
		Zrvl_0030_Export_Func(this, rhs);
	}

	void operator <<=(const tTJSVariant & rhs)
	{
		Zrvl_0031_Export_Func(this, rhs);
	}

	void operator %=(const tTJSVariant & rhs)
	{
		Zrvl_0032_Export_Func(this, rhs);
	}

	void operator /=(const tTJSVariant & rhs)
	{
		Zrvl_0033_Export_Func(this, rhs);
	}

	void idivequal(const tTJSVariant & rhs)
	{
		Zrvl_0034_Export_Func(this, rhs);
	}

	void operator *=(const tTJSVariant & rhs)
	{
		Zrvl_0035_Export_Func(this, rhs);
	}

	void logicalnot()
	{
		Zrvl_0036_Export_Func(this);
	}

	void bitnot()
	{
		Zrvl_0037_Export_Func(this);
	}

	void tonumber()
	{
		Zrvl_0038_Export_Func(this);
	}

	void changesign()
	{
		Zrvl_0039_Export_Func(this);
	}

	void operator -=(const tTJSVariant & rhs)
	{
		Zrvl_003A_Export_Func(this, rhs);
	}

	void operator +=(const tTJSVariant & rhs)
	{
		Zrvl_003B_Export_Func(this, rhs);
	}

	bool NormalCompare(const tTJSVariant & val2) const
	{
		return Zrvl_003C_Export_Func(this, val2);
	}

	bool DiscernCompare(const tTJSVariant & val2) const
	{
		return Zrvl_003D_Export_Func(this, val2);
	}

	bool DiscernCompareStrictReal(const tTJSVariant & val2) const
	{
		return Zrvl_003E_Export_Func(this, val2);
	}

	bool GreaterThan(const tTJSVariant & val2) const
	{
		return Zrvl_003F_Export_Func(this, val2);
	}

	bool LittlerThan(const tTJSVariant & val2) const
	{
		return Zrvl_0040_Export_Func(this, val2);
	}

	bool IsInstanceOf(const tjs_char * classname) const
	{
		return Zrvl_0041_Export_Func(this, classname);
	}

	iTJSDispatch2 * AsObject() const
	{
		return Zrvl_0042_Export_Func(this);
	}

	iTJSDispatch2 * AsObjectNoAddRef() const
	{
		return Zrvl_0043_Export_Func(this);
	}

	iTJSDispatch2 * AsObjectThis() const
	{
		return Zrvl_0044_Export_Func(this);
	}

	iTJSDispatch2 * AsObjectThisNoAddRef() const
	{
		return Zrvl_0045_Export_Func(this);
	}

	tTJSVariantClosure & AsObjectClosureNoAddRef() const
	{
		return Zrvl_0046_Export_Func(this);
	}

	tTJSVariantString * AsString() const
	{
		return Zrvl_0047_Export_Func(this);
	}

	tTJSVariantString * AsStringNoAddRef() const
	{
		return Zrvl_0048_Export_Func(this);
	}

	const tjs_char * GetString() const
	{
		return Zrvl_0049_Export_Func(this);
	}

	tTJSVariantOctet * AsOctet() const
	{
		return Zrvl_004A_Export_Func(this);
	}

	tTJSVariantOctet * AsOctetNoAddRef() const
	{
		return Zrvl_004B_Export_Func(this);
	}

	tTVInteger AsInteger() const
	{
		return Zrvl_004C_Export_Func(this);
	}

	void AsNumber(tTJSVariant & targ) const
	{
		Zrvl_004D_Export_Func(this, targ);
	}

	operator tTVInteger() const
	{
		return Zrvl_004E_Export_Func(this);
	}

	operator bool() const
	{
		return Zrvl_004F_Export_Func(this);
	}

	operator tjs_int() const
	{
		return Zrvl_0050_Export_Func(this);
	}

	tTVReal AsReal() const
	{
		return Zrvl_0051_Export_Func(this);
	}

	operator tTVReal() const
	{
		return Zrvl_0052_Export_Func(this);
	}

	tTJSVariant operator ||(const tTJSVariant & rhs) const
	{
		return Zrvl_0053_Export_Func(this, rhs);
	}

	tTJSVariant operator &&(const tTJSVariant & rhs) const
	{
		return Zrvl_0054_Export_Func(this, rhs);
	}

	tTJSVariant operator |(const tTJSVariant & rhs) const
	{
		return Zrvl_0055_Export_Func(this, rhs);
	}

	tTJSVariant operator ^(const tTJSVariant & rhs) const
	{
		return Zrvl_0056_Export_Func(this, rhs);
	}

	tTJSVariant operator &(const tTJSVariant & rhs) const
	{
		return Zrvl_0057_Export_Func(this, rhs);
	}

	tTJSVariant operator !=(const tTJSVariant & rhs) const
	{
		return Zrvl_0058_Export_Func(this, rhs);
	}

	tTJSVariant operator ==(const tTJSVariant & rhs) const
	{
		return Zrvl_0059_Export_Func(this, rhs);
	}

	tTJSVariant operator <(const tTJSVariant & rhs) const
	{
		return Zrvl_005A_Export_Func(this, rhs);
	}

	tTJSVariant operator >(const tTJSVariant & rhs) const
	{
		return Zrvl_005B_Export_Func(this, rhs);
	}

	tTJSVariant operator <=(const tTJSVariant & rhs) const
	{
		return Zrvl_005C_Export_Func(this, rhs);
	}

	tTJSVariant operator >=(const tTJSVariant & rhs) const
	{
		return Zrvl_005D_Export_Func(this, rhs);
	}

	tTJSVariant operator >>(const tTJSVariant & rhs) const
	{
		return Zrvl_005E_Export_Func(this, rhs);
	}

	tTJSVariant rbitshift(tjs_int count) const
	{
		return Zrvl_005F_Export_Func(this, count);
	}

	tTJSVariant operator <<(const tTJSVariant & rhs) const
	{
		return Zrvl_0060_Export_Func(this, rhs);
	}

	tTJSVariant operator %(const tTJSVariant & rhs) const
	{
		return Zrvl_0061_Export_Func(this, rhs);
	}

	tTJSVariant operator /(const tTJSVariant & rhs) const
	{
		return Zrvl_0062_Export_Func(this, rhs);
	}

	tTJSVariant idiv(const tTJSVariant & rhs) const
	{
		return Zrvl_0063_Export_Func(this, rhs);
	}

	tTJSVariant operator *(const tTJSVariant & rhs) const
	{
		return Zrvl_0064_Export_Func(this, rhs);
	}

	tTJSVariant operator !() const
	{
		return Zrvl_0065_Export_Func(this);
	}

	tTJSVariant operator ~() const
	{
		return Zrvl_0066_Export_Func(this);
	}

	tTJSVariant operator -(const tTJSVariant & rhs) const
	{
		return Zrvl_0067_Export_Func(this, rhs);
	}

	tTJSVariant operator +() const
	{
		return Zrvl_0068_Export_Func(this);
	}

	tTJSVariant operator -() const
	{
		return Zrvl_0069_Export_Func(this);
	}

	tTJSVariant operator +(const tTJSVariant & rhs) const
	{
		return Zrvl_006A_Export_Func(this, rhs);
	}

	static void * operator new(size_t size)
	{
		return Zrvl_006B_Export_Func(size);
	}

	static void operator delete(void * p)
	{
		Zrvl_006C_Export_Func(p);
	}

	static void * operator new [](size_t size)
	{
		return Zrvl_006D_Export_Func(size);
	}

	static void operator delete [](void * p)
	{
		Zrvl_006E_Export_Func(p);
	}

	static void * operator new(size_t size , void * buf)
	{
		return Zrvl_006F_Export_Func(size, buf);
	}

};
//---------------------------------------------------------------------------
// tTJSString
//---------------------------------------------------------------------------

class tTJSString : protected tTJSString_S
{

public:
	tTJSString()
	{
		Zrvl_0078_Export_Func(this);
	}

	tTJSString(const tTJSString & rhs)
	{
		Zrvl_0079_Export_Func(this, rhs);
	}

	tTJSString(tTJSVariantString * vstr)
	{
		Zrvl_007A_Export_Func(this, vstr);
	}

	tTJSString(const tjs_char * str)
	{
		Zrvl_007B_Export_Func(this, str);
	}

	tTJSString(const tjs_nchar * str)
	{
		Zrvl_007C_Export_Func(this, str);
	}

	tTJSString(const tTJSStringBufferLength len)
	{
		Zrvl_007D_Export_Func(this, len);
	}

	tTJSString(tjs_char rch)
	{
		Zrvl_007E_Export_Func(this, rch);
	}

	tTJSString(const tTJSVariant & val)
	{
		Zrvl_007F_Export_Func(this, val);
	}

	tTJSString(const tTJSString & str , int n)
	{
		Zrvl_0080_Export_Func(this, str, n);
	}

	tTJSString(const tjs_char * str , int n)
	{
		Zrvl_0081_Export_Func(this, str, n);
	}

	tTJSString(tjs_int n)
	{
		Zrvl_0082_Export_Func(this, n);
	}

	~ tTJSString()
	{
		Zrvl_0083_Export_Func(this);
	}

	tTJSString & operator =(const tTJSString & rhs)
	{
		return Zrvl_0084_Export_Func(this, rhs);
	}

	tTJSString & operator =(const tjs_char * rhs)
	{
		return Zrvl_0085_Export_Func(this, rhs);
	}

	tTJSString & operator =(const tjs_nchar * rhs)
	{
		return Zrvl_0086_Export_Func(this, rhs);
	}

	void operator +=(const tTJSString & ref)
	{
		Zrvl_0087_Export_Func(this, ref);
	}

	void operator +=(const tTJSVariantString * ref)
	{
		Zrvl_0088_Export_Func(this, ref);
	}

	void operator +=(const tjs_char * ref)
	{
		Zrvl_0089_Export_Func(this, ref);
	}

	void operator +=(tjs_char rch)
	{
		Zrvl_008A_Export_Func(this, rch);
	}

	void Clear()
	{
		Zrvl_008B_Export_Func(this);
	}

	tjs_char * AllocBuffer(tjs_uint len)
	{
		return Zrvl_008C_Export_Func(this, len);
	}

	tjs_char * AppendBuffer(tjs_uint len)
	{
		return Zrvl_008D_Export_Func(this, len);
	}

	void FixLen()
	{
		Zrvl_008E_Export_Func(this);
	}

	void Replace(const tTJSString & from , const tTJSString & to , bool forall = true)
	{
		Zrvl_008F_Export_Func(this, from, to, forall);
	}

	void ToLowerCase()
	{
		Zrvl_0090_Export_Func(this);
	}

	void ToUppserCase()
	{
		Zrvl_0091_Export_Func(this);
	}

	tjs_uint32 * GetHint()
	{
		return Zrvl_0092_Export_Func(this);
	}

	tjs_char * Independ()
	{
		return Zrvl_0093_Export_Func(this);
	}

	const tjs_char * c_str() const
	{
		return Zrvl_0094_Export_Func(this);
	}

	tTJSVariantString * AsVariantStringNoAddRef() const
	{
		return Zrvl_0095_Export_Func(this);
	}

	tjs_int64 AsInteger() const
	{
		return Zrvl_0096_Export_Func(this);
	}

	bool operator ==(const tTJSString & ref) const
	{
		return Zrvl_0097_Export_Func(this, ref);
	}

	bool operator !=(const tTJSString & ref) const
	{
		return Zrvl_0098_Export_Func(this, ref);
	}

	tjs_int CompareIC(const tTJSString & ref) const
	{
		return Zrvl_0099_Export_Func(this, ref);
	}

	bool operator ==(const tjs_char * ref) const
	{
		return Zrvl_009A_Export_Func(this, ref);
	}

	bool operator !=(const tjs_char * ref) const
	{
		return Zrvl_009B_Export_Func(this, ref);
	}

	tjs_int CompareIC(const tjs_char * ref) const
	{
		return Zrvl_009C_Export_Func(this, ref);
	}

	bool operator <(const tTJSString & ref) const
	{
		return Zrvl_009D_Export_Func(this, ref);
	}

	bool operator >(const tTJSString & ref) const
	{
		return Zrvl_009E_Export_Func(this, ref);
	}

	tTJSString operator +(const tTJSString & ref) const
	{
		return Zrvl_009F_Export_Func(this, ref);
	}

	tTJSString operator +(const tjs_char * ref) const
	{
		return Zrvl_00A0_Export_Func(this, ref);
	}

	tTJSString operator +(tjs_char rch) const
	{
		return Zrvl_00A1_Export_Func(this, rch);
	}

	tjs_char operator [](tjs_uint i) const
	{
		return Zrvl_00A2_Export_Func(this, i);
	}

	void AsLowerCase(tTJSString & dest) const
	{
		Zrvl_00A3_Export_Func(this, dest);
	}

	void AsUpperCase(tTJSString & dest) const
	{
		Zrvl_00A4_Export_Func(this, dest);
	}

	void EscapeC(tTJSString & dest) const
	{
		Zrvl_00A5_Export_Func(this, dest);
	}

	void UnescapeC(tTJSString & dest) const
	{
		Zrvl_00A6_Export_Func(this, dest);
	}

	bool StartsWith(const tjs_char * string) const
	{
		return Zrvl_00A7_Export_Func(this, string);
	}

	bool StartsWith(const tTJSString & string) const
	{
		return Zrvl_00A8_Export_Func(this, string);
	}

	tjs_int GetNarrowStrLen() const
	{
		return Zrvl_00A9_Export_Func(this);
	}

	void ToNarrowStr(tjs_nchar * dest , tjs_int destmaxlen) const
	{
		Zrvl_00AA_Export_Func(this, dest, destmaxlen);
	}

	bool IsEmpty() const
	{
		return Zrvl_00AB_Export_Func(this);
	}

	tjs_int GetLen() const
	{
		return Zrvl_00AC_Export_Func(this);
	}

	tjs_int length() const
	{
		return Zrvl_00AD_Export_Func(this);
	}

	tjs_char GetLastChar() const
	{
		return Zrvl_00AE_Export_Func(this);
	}

	static void * operator new(size_t size)
	{
		return Zrvl_00AF_Export_Func(size);
	}

	static void operator delete(void * p)
	{
		Zrvl_00B0_Export_Func(p);
	}

	static void * operator new [](size_t size)
	{
		return Zrvl_00B1_Export_Func(size);
	}

	static void operator delete [](void * p)
	{
		Zrvl_00B2_Export_Func(p);
	}

	static void * operator new(size_t size , void * buf)
	{
		return Zrvl_00B3_Export_Func(size, buf);
	}

	
	friend tTJSString operator + (const tjs_char *lhs, const tTJSString &rhs);
	

};

//---------------------------------------------------------------------------
// stubs (misc)
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
// stubs
//---------------------------------------------------------------------------

inline tjs_int TJS_atoi(const tjs_char * s)
{
	return Zrvl_00C5_Export_Func(s);
}
inline tjs_char * TJS_int_to_str(tjs_int value , tjs_char * string)
{
	return Zrvl_00C6_Export_Func(value, string);
}
inline tjs_char * TJS_tTVInt_to_str(tjs_int64 value , tjs_char * string)
{
	return Zrvl_00C7_Export_Func(value, string);
}
inline tjs_int TJS_strnicmp(const tjs_char * s1 , const tjs_char * s2 , size_t maxlen)
{
	return Zrvl_00C8_Export_Func(s1, s2, maxlen);
}
inline tjs_int TJS_stricmp(const tjs_char * s1 , const tjs_char * s2)
{
	return Zrvl_00C9_Export_Func(s1, s2);
}
inline void TJS_strcpy_maxlen(tjs_char * d , const tjs_char * s , size_t len)
{
	Zrvl_00CA_Export_Func(d, s, len);
}
inline void TJS_strcpy(tjs_char * d , const tjs_char * s)
{
	Zrvl_00CB_Export_Func(d, s);
}
inline size_t TJS_strlen(const tjs_char * d)
{
	return Zrvl_00CC_Export_Func(d);
}
inline tjs_char * TJSVS_malloc(tjs_uint len)
{
	return Zrvl_00CD_Export_Func(len);
}
inline tjs_char * TJSVS_realloc(tjs_char * buf , tjs_uint len)
{
	return Zrvl_00CE_Export_Func(buf, len);
}
inline void TJSVS_free(tjs_char * buf)
{
	Zrvl_00CF_Export_Func(buf);
}
inline tTJSVariantString * TJSAllocVariantString(const tjs_char * ref1 , const tjs_char * ref2)
{
	return Zrvl_00D0_Export_Func(ref1, ref2);
}
inline tTJSVariantString * TJSAllocVariantString(const tjs_char * ref , tjs_int n)
{
	return Zrvl_00D1_Export_Func(ref, n);
}
inline tTJSVariantString * TJSAllocVariantString(const tjs_char * ref)
{
	return Zrvl_00D2_Export_Func(ref);
}
inline tTJSVariantString * TJSAllocVariantString(const tjs_nchar * ref)
{
	return Zrvl_00D3_Export_Func(ref);
}
inline tTJSVariantString * TJSAllocVariantString(const tjs_uint8 * * src)
{
	return Zrvl_00D4_Export_Func(src);
}
inline tTJSVariantString * TJSAllocVariantStringBuffer(tjs_uint len)
{
	return Zrvl_00D5_Export_Func(len);
}
inline tTJSVariantString * TJSAppendVariantString(tTJSVariantString * str , const tjs_char * app)
{
	return Zrvl_00D6_Export_Func(str, app);
}
inline tTJSVariantString * TJSAppendVariantString(tTJSVariantString * str , const tTJSVariantString * app)
{
	return Zrvl_00D7_Export_Func(str, app);
}
inline tTJSVariantString * TJSFormatString(const tjs_char * format , tjs_uint numparams , tTJSVariant * * params)
{
	return Zrvl_00D8_Export_Func(format, numparams, params);
}
inline const tjs_char * TJSVariantTypeToTypeString(tTJSVariantType type)
{
	return Zrvl_00D9_Export_Func(type);
}
inline tTJSString TJSVariantToReadableString(const tTJSVariant & val , tjs_int maxlen = 512)
{
	return Zrvl_00DA_Export_Func(val, maxlen);
}
inline tTJSString TJSVariantToExpressionString(const tTJSVariant & val)
{
	return Zrvl_00DB_Export_Func(val);
}
inline void * TJSAlignedAlloc(tjs_uint bytes , tjs_uint align_bits)
{
	return Zrvl_00DC_Export_Func(bytes, align_bits);
}
inline void TJSAlignedDealloc(void * ptr)
{
	Zrvl_00DD_Export_Func(ptr);
}
inline tjs_uint32 TJSGetFPClass(tjs_real r)
{
	return Zrvl_00DE_Export_Func(r);
}
inline tTJSString operator +(const tjs_char * lhs , const tTJSString & rhs)
{
	return Zrvl_00DF_Export_Func(lhs, rhs);
}
inline tTJSString TJSInt32ToHex(tjs_uint32 num , int zeropad = 8)
{
	return Zrvl_00E0_Export_Func(num, zeropad);
}
inline tjs_int32 TJSRegisterNativeClass(const tjs_char * name)
{
	return Zrvl_00E1_Export_Func(name);
}
inline tjs_int32 TJSFindNativeClassID(const tjs_char * name)
{
	return Zrvl_00E2_Export_Func(name);
}
inline const tjs_char * TJSFindNativeClassName(tjs_int32 id)
{
	return Zrvl_00E3_Export_Func(id);
}
inline tTJSNativeClassMethod * TJSCreateNativeClassMethod(tTJSNativeClassMethodCallback callback)
{
	return Zrvl_00E4_Export_Func(callback);
}
inline tTJSNativeClassMethod * TJSCreateNativeClassConstructor(tTJSNativeClassMethodCallback callback)
{
	return Zrvl_00E5_Export_Func(callback);
}
inline tTJSNativeClassProperty * TJSCreateNativeClassProperty(tTJSNativeClassPropertyGetCallback get , tTJSNativeClassPropertySetCallback set)
{
	return Zrvl_00E6_Export_Func(get, set);
}
inline void TJSNativeClassRegisterNCM(tTJSNativeClass * cls , const tjs_char * name , iTJSDispatch2 * dsp , const tjs_char * classname , tTJSNativeInstanceType type , tjs_uint32 flags = 0)
{
	Zrvl_00E7_Export_Func(cls, name, dsp, classname, type, flags);
}
inline void TJSNativeClassSetClassID(tTJSNativeClass * cls , tjs_int32 classid)
{
	Zrvl_00E8_Export_Func(cls, classid);
}
inline tTJSNativeClassForPlugin * TJSCreateNativeClassForPlugin(const ttstr & name , tTJSCreateNativeInstance createinstance)
{
	return Zrvl_00E9_Export_Func(name, createinstance);
}
inline void TJSThrowNullAccess()
{
	Zrvl_00EA_Export_Func();
}
inline void TJSThrowDivideByZero()
{
	Zrvl_00EB_Export_Func();
}
inline tTJSVariantOctet * TJSAllocVariantOctet(const tjs_uint8 * data , tjs_uint length)
{
	return Zrvl_00EC_Export_Func(data, length);
}
inline tTJSVariantOctet * TJSAllocVariantOctet(const tjs_uint8 * data1 , tjs_uint len1 , const tjs_uint8 * data2 , tjs_uint len2)
{
	return Zrvl_00ED_Export_Func(data1, len1, data2, len2);
}
inline tTJSVariantOctet * TJSAllocVariantOctet(const tTJSVariantOctet * o1 , const tTJSVariantOctet * o2)
{
	return Zrvl_00EE_Export_Func(o1, o2);
}
inline tTJSVariantOctet * TJSAllocVariantOctet(const tjs_uint8 * * src)
{
	return Zrvl_00EF_Export_Func(src);
}
inline void TJSDeallocVariantOctet(tTJSVariantOctet * o)
{
	Zrvl_00F0_Export_Func(o);
}
inline tTJSVariantString * TJSOctetToListString(const tTJSVariantOctet * oct)
{
	return Zrvl_00F1_Export_Func(oct);
}
inline tTJSVariantString * TJSObjectToString(const tTJSVariantClosure & dsp)
{
	return Zrvl_00F2_Export_Func(dsp);
}
inline tTJSVariantString * TJSIntegerToString(tjs_int64 i)
{
	return Zrvl_00F3_Export_Func(i);
}
inline tTJSVariantString * TJSRealToString(tjs_real r)
{
	return Zrvl_00F4_Export_Func(r);
}
inline tTJSVariantString * TJSRealToHexString(tjs_real r)
{
	return Zrvl_00F5_Export_Func(r);
}
inline tTVInteger TJSStringToInteger(const tjs_char * str)
{
	return Zrvl_00F6_Export_Func(str);
}
inline tTVReal TJSStringToReal(const tjs_char * str)
{
	return Zrvl_00F7_Export_Func(str);
}
inline iTJSDispatch2 * TJSCreateArrayObject(iTJSDispatch2 * * classout = NULL)
{
	return Zrvl_00F8_Export_Func(classout);
}
inline tjs_int TJSGetArrayElementCount(iTJSDispatch2 * dsp)
{
	return Zrvl_00F9_Export_Func(dsp);
}
inline tjs_int TJSCopyArrayElementTo(iTJSDispatch2 * dsp , tTJSVariant * dest , tjs_uint start , tjs_int count)
{
	return Zrvl_00FA_Export_Func(dsp, dest, start, count);
}
inline iTJSDispatch2 * TJSCreateDictionaryObject(iTJSDispatch2 * * classout = NULL)
{
	return Zrvl_00FB_Export_Func(classout);
}
inline ttstr TJSGetMessageMapMessage(const tjs_char * name)
{
	return Zrvl_00FC_Export_Func(name);
}
inline ttstr TJSMapGlobalStringMap(const ttstr & string)
{
	return Zrvl_00FD_Export_Func(string);
}
inline void TJSDoVariantOperation(tjs_int op , tTJSVariant & target , const tTJSVariant * param)
{
	Zrvl_00FE_Export_Func(op, target, param);
}
inline void TJSDoRehash()
{
	Zrvl_00FF_Export_Func();
}
inline iTJSDispatch2 * TJSCreateCustomObject()
{
	return Zrvl_0100_Export_Func();
}

#ifdef __BORLANDC__
#pragma warn .8027
#endif

//---------------------------------------------------------------------------
// Global reference count
//---------------------------------------------------------------------------
extern tjs_int ZrvlPluginGlobalRefCount;
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// exception protected function stub
//---------------------------------------------------------------------------


#endif
